<?php
class forum_mmoo_content_edit_post extends forum_mmoo_content{
	function __construct($request=array()){
		parent::__construct($request);
	}
	
	function setOutputMain(){
		include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
		$this->objTopics = new forum_mmoo_data_topics();
		$this->topicInfo = $this->objTopics->getTopicInfo($this->request['forum_mmoo_topic']);
		
		if( $this->memberInfo['post'] == FORUM_MMOO_FLAG_NO ){
			$this->invalid();
			return;
		}
		
		if( !empty($this->request['forum_mmoo_self']) && $this->memberInfo['edit_own']==FORUM_MMOO_FLAG_NO){
			$this->invalid();
			return;
		}
		
		include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
		$this->objThread = new forum_mmoo_data_thread( $this->request['forum_mmoo_topic'] );
		
		if( empty($this->request['forum_mmoo_self']) ){
			$this->oldData = null;
		}else{
			$this->oldData = $this->objThread->getPost($this->request['forum_mmoo_self']);
			if( $this->memberInfo['edit_other']==FORUM_MMOO_FLAG_NO && $this->memberInfo['member_id']!=$this->oldData['posted_by'] ){
				$this->invalid();
				return;
			}
			$this->request['forum_mmoo_parent'] = $this->oldData['direct_parent'];
		}
		
		if( empty($this->request['forum_mmoo_parent']) ){
			$this->parentData = null;
		}else{
			$this->parentData = $this->objThread->getPost($this->request['forum_mmoo_parent']);
		}
		
		if( $this->request['forum_mmoo_send_data']==1 ){
			$this->tryEdit();
		}else{
			$this->showTry();
		}
	}
	
	function invalid(){
		$this->outputMain .= $this->copyOutputMain('posts', array('forum_mmoo_topic'=>$this->request['forum_mmoo_topic']) );
	}
	
	function showTry(){
		include_once(FORUM_MMOO_FUNCTIONS_DIR.'editor.php');
		
		$this->topLinks[] = array(
			'act' => 'posts'
			, 'option' => array( 'forum_mmoo_topic' => $this->request['forum_mmoo_topic'] )
			, 'text' => 'to the topic "'.forum_mmoo_excerpt($this->topicInfo['title'],FORUM_MMOO_TOPIC_SHORTEN).'"'
		);
		
		if( empty($this->oldData) ){
			$this->outputMain .= '<span class="forum_mmoo-page_title">Post to the topic "'.$this->topicInfo['title'].'"</span>';
			$hiddenSelf = '';
			$oldTitle = '';
			$oldContent = '';
			$submitValue = "POST";
		}else{
			$this->outputMain .= '<span class="forum_mmoo-page_title">EDIT POST</span>';
			$hiddenSelf = '<input type="hidden" name="forum_mmoo_self" value="'.$this->oldData['id'].'">';
			$oldTitle = $this->oldData['title'];
			$oldContent = wp_kses_decode_entities( $this->oldData['content'] );
			$submitValue = "EDIT";
		}
		
		if( empty($this->parentData) ){
			$hiddenParent = '';
		}else{
			$this->outputMain .= '<p style="margin: 1em 0em 0em 0em;">Reply to the post below:</p>';
			$this->outputMain .= '<div class="forum_mmoo-post_title_box" style="margin-top:0.2em;"><span class="forum_mmoo-post_title">'.$this->parentData['title'].'</span></div>';
			$this->outputMain .= '<div class="forum_mmoo-post_content_box">';
			$this->outputMain .= '<span class="forum_mmoo-post_by"> by : '.$this->getMemberLink($this->parentData['posted_by']).'</span>';
			$this->outputMain .= '<span class="forum_mmoo-post_update">last update: '.forum_mmoo_convert_datetime($this->parentData['updated_time']).'</span>';
			$this->outputMain .= '<br><hr>';
			$this->outputMain .= $this->parentData['content'];
			$this->outputMain .= '</div>';
			$hiddenParent = '<input type="hidden" name="forum_mmoo_parent" value="'.$this->parentData['id'].'">';
		}
		
		$this->outputMain .= '<form name="forum_mmoo_form" method=post action="'.forum_mmoo_make_content_url('edit_post').'">';
		$this->outputMain .= '<input type="hidden" name="forum_mmoo_send_data" value="1">';
		$this->outputMain .= '<input type="hidden" name="forum_mmoo_topic" value="'.$this->request['forum_mmoo_topic'].'">';
		$this->outputMain .= $hiddenSelf;
		$this->outputMain .= $hiddenParent;
		$this->outputMain .= '<div class="forum_mmoo-edit_post">';
		$this->outputMain .= '<span class="forum_mmoo-label_post_title">TITLE : </span><input type="text" class="forum_mmoo-topic_title" name="forum_mmoo_post_title" value="'.$oldTitle.'">';
		$this->outputMain .= forum_mmoo_editor($oldContent, 'forum_mmoo_post_content');
		$this->outputMain .= '<div align="center"><span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form.submit();">'.$submitValue.'</span></div>';
		$this->outputMain .= '</div>';
		$this->outputMain .= '</form>';
	}
	
	function tryEdit(){
		$title = wp_kses_post($this->request['forum_mmoo_post_title']);
		$content = wpautop(wp_kses_post($this->request['forum_mmoo_post_content']));
		
		if( empty($this->oldData) ){
			$insertRow = array();
			$insertRow['title'] = $title;
			$insertRow['posted_by'] = $this->memberInfo['member_id'];
			$insertRow['posted_date'] = $this->objThread->now;
			$insertRow['content'] = $content;
			if( empty($this->parentData) ){
				$insertRow['depth'] = 0;
			}else{
				$insertRow['direct_parent'] = $this->parentData['id'];
				if( empty($this->parentData['first_parent']) ){
					$insertRow['first_parent'] = $this->parentData['id'];
				}else{
					$insertRow['first_parent'] = $this->parentData['first_parent'];
				}
				$insertRow['depth'] = $this->parentData['depth'] + 1;
			}
			if( $this->objThread->executeInsert($insertRow) ){
				include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
				$objExplanation = new forum_mmoo_data_explanation();
				include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
				
				include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
				$objMembers = new forum_mmoo_data_members();
				
				include_once(FORUM_MMOO_DATA_DIR.'data_notify_topic.php');
				$objNotifyTopic = new forum_mmoo_data_notify_topic();
				$topicNotifyMembersId = $objNotifyTopic->getDataForTopic($this->request['forum_mmoo_topic']);
				
				if( !empty($topicNotifyMembersId) ){
					$topicNotifyMembers = $objMembers->getMemberInfoByArrId($topicNotifyMembersId,'strict');
					$mailData = $objExplanation->getData('notify_topic');
					foreach($topicNotifyMembers as $member){
						$mailContent = forum_mmoo_replace_mail_tag($mailData['content'],array('member_id'=>$member['id'], 'topic_id'=>$this->request['forum_mmoo_topic']));
						@forum_mmoo_mail($member['mail'], $mailData['title'], $mailContent);
					}
				}
				
				if( !empty($this->parentData['id']) ){
					include_once(FORUM_MMOO_DATA_DIR.'data_notify_reply.php');
					$objNotifyReply = new forum_mmoo_data_notify_reply();
					$replyNotifyMembersId = $objNotifyReply->getDataForPost($this->request['forum_mmoo_topic'], $this->parentData['id']);
					if( !empty($replyNotifyMembersId) ){
						$replyNotifyMembers = $objMembers->getMemberInfoByArrId($replyNotifyMembersId,'strict');
						$mailData = $objExplanation->getData('notify_reply');
						foreach($replyNotifyMembers as $member){
							$mailContent = forum_mmoo_replace_mail_tag($mailData['content'],array('member_id'=>$member['id'],'topic_id'=>$this->request['forum_mmoo_topic'], 'post_id'=>$this->parentData['id']));
							@forum_mmoo_mail($member['mail'], $mailData['title'], $mailContent);
						}
					}
				}
				
				$this->outputMain .= '<div id="forum_mmoo-success_message">Posted!</div>';
				
				$maxId = $this->objThread->executeSelectOne( array('max(id) as new_id') );
				$option = array(
					'forum_mmoo_topic' => $this->request['forum_mmoo_topic']
					, 'forum_mmoo_post' => $maxId['new_id']
				);
			}else{
				$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to post. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
				$option = array(
					'forum_mmoo_topic' => $this->request['forum_mmoo_topic']
				);
			}
		}else{
			if( $this->objThread->executeUpdate( array('title'=>$title, 'content'=>$content), array('id'=>$this->oldData['id'])) ){
				$this->outputMain .= '<div id="forum_mmoo-success_message">Edited the post!</div>';
			}else{
				$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to edit the post. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
			}
			
			$sessionData = forum_mmoo_get_session();
			if( $sessionData['backPage']['act'] == 'posts'){
				$option = $sessionData['backPage']['option'];
			}else{
				$option = array('forum_mmoo_topic' => $this->request['forum_mmoo_topic']);
			}
			$option['forum_mmoo_post'] = $this->oldData['id'];
		}
		$this->outputMain .= $this->copyOutputMain('posts', $option);
	}
}
?>