<?php
class forum_mmoo_content_edit_profile extends forum_mmoo_content{
	var $oldInfo = array();
	var $requiredForLoginId = array();
	var $requiredForPassword = array();
	var $requiredForMail = array();
	var $requiredForProfile = array();
	
	function __construct($request=array()){
		parent::__construct($request);
		$this->needSocialButtons = false;
	}
	
	function setBackPage(){
		$backPage = array();
		$backPage['act'] = 'edit_profile';
		$backPage['option'] = array();
		$backPage['text'] = 'Profile';
		forum_mmoo_set_session( 'backPage', $backPage );
	}
	
	function setOutputMain(){
		if( empty($this->memberInfo['member_id']) ){
			$this->needLinkToList = false;
			$this->outputMain .= $this->copyOutputMain('list');
		}else{
			include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
			$this->objMembers = new forum_mmoo_data_members();
			$this->oldInfo = $this->objMembers->getMemberInfoById( $this->memberInfo['member_id'] , 'strict' );
			
			include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
			$objMemberInfo = new forum_mmoo_data_member_info();
			$requiredData = $objMemberInfo->getData(true);
			
			foreach($requiredData as $id => $val){
				if( $val['member_col_name']=='login_id' ){
					$this->requiredForLoginId = $val;
				}elseif( $val['member_col_name']=='password' ){
					$this->requiredForPassword = $val;
				}elseif( $val['member_col_name']=='mail' ){
					$this->requiredForMail = $val;
				}else{
					$this->requiredForProfile[$id] = $val;
				}
			}
			
			include_once( FORUM_MMOO_CONTENT_DIR."content_register.php");
			$this->objRegister = new forum_mmoo_content_register();
			
			switch( $this->request['change'] ){
				case 'login_id':
					$this->changeLoginId();
				break;
				case 'password':
					$this->changePassword();
				break;
				case 'notify_message':
					$this->changeNofityMessage();
				break;
				case 'mail':
					$this->changeMail();
				break;
				case 'profile':
					$this->changeProfile();
				break;
				default:
				break;
			}
			$this->showTry();
		}
	}
	
	function showTry(){
		$this->outputMain .= '<span class="forum_mmoo-page_title">GENERAL</span>';
		$this->outputMain .= '<table class="forum_mmoo-table_change_basic">';
		if( !empty($this->requiredForLoginId) ){
			$this->outputMain .= '<form name="forum_mmoo_form_login_id" method="post" action="'.forum_mmoo_make_content_url('edit_profile').'">';
			$this->outputMain .= '<input type="hidden" name="change" value="login_id">';
			$this->outputMain .= '<tr>';
			$this->outputMain .= '<th>'.$this->requiredForLoginId['question'].'</th>';
			$this->outputMain .= '<td>';
			$this->outputMain .= '<input type="text" class="forum_mmoo-login_id" name="login_id" value="'.$this->oldInfo['login_id'].'" style="ime-mode:disabled;">';
			$this->outputMain .= '</td>';
			$this->outputMain .= '<td style="width:4em; text-align:center;">';
			$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form_login_id.submit();">Change</span>';
			$this->outputMain .= '</td>';
			$this->outputMain .= '</tr>';
			$this->outputMain .= '</form>';
		}
		
		$this->outputMain .= '<form name="forum_mmoo_form_mail" method="post" action="'.forum_mmoo_make_content_url('edit_profile').'">';
		$this->outputMain .= '<input type="hidden" name="change" value="mail">';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<th>'.$this->requiredForMail['question'].'</th>';
		$this->outputMain .= '<td>';
		$this->outputMain .= '<input type="text" class="forum_mmoo-mail" name="mail" value="'.$this->oldInfo['mail'].'" style="ime-mode:disabled;">';
		$this->outputMain .= '</td>';
		$this->outputMain .= '<td style="text-align:center;">';
		$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form_mail.submit();">Change</span>';
		$this->outputMain .= '</td>';
		$this->outputMain .= '</tr>';
		$this->outputMain .= '</form>';
		
		$this->outputMain .= '<form name="forum_mmoo_form_password" method="post" action="'.forum_mmoo_make_content_url('edit_profile').'">';
		$this->outputMain .= '<input type="hidden" name="change" value="password">';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<th>'.$this->requiredForPassword['question'].'</th>';
		$this->outputMain .= '<td>';
		$this->outputMain .= '<input type="password" class="forum_mmoo-password" name="password">';
		$this->outputMain .= '</td>';
		$this->outputMain .= '<td style="text-align:center;">';
		$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form_password.submit();">Change</span>';
		$this->outputMain .= '</td>';
		$this->outputMain .= '</tr>';
		$this->outputMain .= '</form>';
		
		include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
		$objGroup = new forum_mmoo_data_group();
		$groupInfo = $objGroup->getGroupData($this->oldInfo['group_id']);
		if( $groupInfo['notify_message'] == FORUM_MMOO_FLAG_YES ){
			$this->outputMain .= '<form name="forum_mmoo_form_notify_message" method="post" action="'.forum_mmoo_make_content_url('edit_profile').'">';
			$this->outputMain .= '<input type="hidden" name="change" value="notify_message">';
			$this->outputMain .= '<tr>';
			$this->outputMain .= '<th>notifying mail</th>';
			$this->outputMain .= '<td>';
			if( $this->oldInfo['message_notify']==FORUM_MMOO_FLAG_YES ){
				$this->outputMain .= 'You are now receiving notifying mails.';
			}else{
				$this->outputMain .= 'Now you are NOT receiving notifying mails.';
			}
			$this->outputMain .= '</td>';
			$this->outputMain .= '<td style="text-align:center;">';
			$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form_notify_message.submit();">';
			if( $this->oldInfo['message_notify']==FORUM_MMOO_FLAG_YES ){
				$this->outputMain .= 'Stop It';
			}else{
				$this->outputMain .= 'Start';
			}
			$this->outputMain .= '</span>';
			$this->outputMain .= '</td>';
			$this->outputMain .= '</tr>';
			$this->outputMain .= '</form>';
		}
		
		$this->outputMain .= '</table>';
		
		$this->outputMain .= '<span class="forum_mmoo-page_title">YOUR PROFILE</span>';
		$this->outputMain .= '<form name="forum_mmoo_form_profile" method="post" action="'.forum_mmoo_make_content_url('edit_profile').'">';
		$this->outputMain .= '<input type="hidden" name="change" value="profile">';
		$this->outputMain .= '<table class="forum_mmoo-table_change_profile">';
		$this->outputMain .= $this->objRegister->getInputTable($this->requiredForProfile, $this->oldInfo, $this->errors);
		$this->outputMain .= '</table>';
		$this->outputMain .= '<div align="center" style="margin:0em 0em 1.5em 0em;"><span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form_profile.submit();">Change Your Profile</span></div>';
		$this->outputMain .= '</form>';
		
		$topics = null;
		if( $this->memberInfo['notify_update']==FORUM_MMOO_FLAG_YES ){
			$this->outputMain .= '<span class="forum_mmoo-page_title">The Topics You Are Receiving Notifying Mails For Updates</span>';
			
			include_once(FORUM_MMOO_DATA_DIR.'data_notify_topic.php');
			$objNotifyTopic = new forum_mmoo_data_notify_topic();
			$topicsNotified = $objNotifyTopic->getDataForMember($this->memberInfo['member_id']);
			
			if( empty($topicsNotified) ){
				$this->outputMain .= '<p class="forum_mmoo-comment">Now you are NOT receiving notifying mails for ANY topic.</p>';
			}else{
				include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
				$objTopics = new forum_mmoo_data_topics();
				$topics = $objTopics->getData();
				
				$this->outputMain .= '<table class="forum_mmoo-table_change_topic_notify">';
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<th style="width:60%;">TOPIC</th>';
				$this->outputMain .= '<th>CREATED BY</th>';
				$this->outputMain .= '<th style="width:4em;">MAIL</th>';
				$this->outputMain .= '</tr>';
				foreach( $topicsNotified as $topicId => $dummy ){
					$this->outputMain .= '<tr>';
					$this->outputMain .= '<td>';
					$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic'=>$topicId), $topics[$topicId]['blog_page']).'">';
					$this->outputMain .= forum_mmoo_excerpt($topics[$topicId]['title'],FORUM_MMOO_TOPIC_SHORTEN);
					$this->outputMain .= '</a>';
					$this->outputMain .= '</td>';
					$this->outputMain .= '<td>';
					$this->outputMain .= $this->getMemberLink($topics[$topicId]['created_by']);
					$this->outputMain .= '</td>';
					$this->outputMain .= '<td>';
					$this->outputMain .= '<a class="forum_mmoo-psudo_button" style="margin:0;" href="'.forum_mmoo_make_content_url('notify_topic',array('forum_mmoo_topic'=>$topicId, 'change'=>'stop')).'">Stop</a>';
					$this->outputMain .= '</td>';
					$this->outputMain .= '</tr>';
				}
				$this->outputMain .= '</table>';
			}
		}
		
		if( $this->memberInfo['notify_own']==FORUM_MMOO_FLAG_YES || $this->memberInfo['notify_other']==FORUM_MMOO_FLAG_YES ){
			$this->outputMain .= '<span class="forum_mmoo-page_title">The Posts You Are Receiving Notifying Mails When Replied</span>';
			
			include_once(FORUM_MMOO_DATA_DIR.'data_notify_reply.php');
			$objNotifyReply = new forum_mmoo_data_notify_reply();
			$postsNofitied = $objNotifyReply->getDataForMemberAllTopic($this->memberInfo['member_id']);
			
			if( empty($postsNofitied) ){
				$this->outputMain .= '<p class="forum_mmoo-comment">Now you are NOT receiving notifying mails for ANY post.</p>';
			}else{
				if( empty($topics) ){
					include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
					$objTopics = new forum_mmoo_data_topics();
					$topics = $objTopics->getData();
				}
				
				$this->outputMain .= '<table class="forum_mmoo-table_change_post_notify">';
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<th>TOPIC</th>';
				$this->outputMain .= '<th>POST</th>';
				$this->outputMain .= '<th style="width:4em;">MAIL</th>';
				$this->outputMain .= '</tr>';
				include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
				foreach( $postsNofitied as $topicId => $arrPostId ){
					$objThread = new forum_mmoo_data_thread($topicId);
					$postsInTopic = $objThread->getPosts($arrPostId);
					$this->outputMain .= '<tr>';
					$this->outputMain .= '<td rowspan="'.count($arrPostId).'">';
					$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic'=>$topicId), $topics[$topicId]['blog_page']).'">';
					$this->outputMain .= forum_mmoo_excerpt($topics[$topicId]['title'],FORUM_MMOO_TOPIC_SHORTEN);
					$this->outputMain .= '</a>';
					$this->outputMain .= '</td>';
					$tr = '';
					foreach($postsInTopic as $postInfo){
						$this->outputMain .= $tr;
						$this->outputMain .= '<td>';
						$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic'=>$topicId, 'forum_mmoo_post'=>$postInfo['id']), $topics[$topicId]['blog_page']).'">';
						$postTitle = forum_mmoo_excerpt($postInfo['title'],FORUM_MMOO_POST_SHORTEN);
						if( strlen($postTitle)==0 ){
							$postTitle = 'No Title';
						}
						$this->outputMain .= $postTitle;
						$this->outputMain .= '</a>';
						$this->outputMain .= '</td>';
						$this->outputMain .= '<td>';
						$this->outputMain .= '<a class="forum_mmoo-psudo_button" style="margin:0;"';
						$this->outputMain .= ' href="'.forum_mmoo_make_content_url('notify_reply',array('forum_mmoo_topic'=>$topicId, 'forum_mmoo_post'=>$postInfo['id'], 'change'=>'stop')).'">';
						$this->outputMain .= 'Stop</a>';
						$this->outputMain .= '</td>';
						$this->outputMain .= '</tr>';
						$tr = '<tr>';
					}
				}
				$this->outputMain .= '</table>';
			}
		}
		$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('leave').'">LEAVE THE FORUM</a>';
	}
	
	function changeLoginId(){
		$decodedInput = $this->objRegister->decodeInput(array($this->requiredForLoginId), $this->request, $this->memberInfo['member_id']);
		$this->oldInfo['login_id'] = $decodedInput['insertRow']['login_id'];
		if( $decodedInput['errorType']['required'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'You canNOT delete '.$this->requiredForLoginId['question'];
			$this->outputMain .= '</div>';
		}elseif( $decodedInput['errorType']['duplicate'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'Sorry, please try another '.$this->requiredForLoginId['question'];
			$this->outputMain .= '</div>';
		}else{
			$already = $this->objMembers->getMemberInfoByLoginData( array('login_id'=>$decodedInput['insertRow']['login_id'], 'password'=>$this->oldInfo['password']) );
			if( !empty($already) && $already['id']!=$this->memberInfo['member_id'] ){
				$this->outputMain .= '<div id="forum_mmoo-error_message">';
				$this->outputMain .= 'Sorry, please try another '.$this->requiredForLoginId['question'];
				$this->outputMain .= '</div>';
			}else{
				if( $this->objMembers->executeUpdate( array('login_id'=>$decodedInput['insertRow']['login_id']), array('id'=>$this->memberInfo['member_id']) ) ){
					$this->outputMain .= '<div id="forum_mmoo-success_message">';
					$this->outputMain .= 'Your '.$this->requiredForLoginId['question'].' changed.';
					$this->outputMain .= '</div>';
				}else{
					$this->outputMain .= '<div id="forum_mmoo-error_message">';
					$this->outputMain .= 'Failed to change your '.$this->requiredForLoginId['question'].FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
					$this->outputMain .= '</div>';
				}
			}
		}
	}
	
	function changePassword(){
		$decodedInput = $this->objRegister->decodeInput(array($this->requiredForPassword), $this->request, $this->memberInfo['member_id']);
		$this->oldInfo['password'] = $decodedInput['insertRow']['password'];
		if( $decodedInput['errorType']['required'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'You canNOT delete '.$this->requiredForPassword['question'];
			$this->outputMain .= '</div>';
		}elseif( $decodedInput['errorType']['duplicate'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'Sorry, please try another '.$this->requiredForPassword['question'];
			$this->outputMain .= '</div>';
		}else{
			$already = $this->objMembers->getMemberInfoByLoginData( array('login_id'=>$this->oldInfo['login_id'], 'password'=>$decodedInput['insertRow']['password'], 'mail'=>$this->oldInfo['mail']) );
			if( !empty($already) && $already['id']!=$this->memberInfo['member_id'] ){
				$this->outputMain .= '<div id="forum_mmoo-error_message">';
				$this->outputMain .= 'Sorry, please try another '.$this->requiredForPassword['question'];
				$this->outputMain .= '</div>';
			}else{
				if( $this->objMembers->executeUpdate( array('password'=>$decodedInput['insertRow']['password']), array('id'=>$this->memberInfo['member_id']), false ) ){
					$this->outputMain .= '<div id="forum_mmoo-success_message">';
					$this->outputMain .= 'Your '.$this->requiredForPassword['question'].' changed.';
					$this->outputMain .= '</div>';
				}else{
					$this->outputMain .= '<div id="forum_mmoo-error_message">';
					$this->outputMain .= 'Failed to change your '.$this->requiredForPassword['question'].FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
					$this->outputMain .= '</div>';
				}
			}
		}
	}
	
	function changeMail(){
		$decodedInput = $this->objRegister->decodeInput(array($this->requiredForMail), $this->request, $this->memberInfo['member_id']);
		$this->oldInfo['mail'] = $decodedInput['insertRow']['mail'];
		if( $decodedInput['errorType']['required'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'You canNOT delete '.$this->requiredForMail['question'];
			$this->outputMain .= '</div>';
		}elseif( $decodedInput['errorType']['duplicate'] ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'Sorry, please try another '.$this->requiredForMail['question'];
			$this->outputMain .= '</div>';
		}else{
			$already = $this->objMembers->getMemberInfoByLoginData( array('login_id'=>$this->oldInfo['login_id'], 'password'=>$this->oldInfo['password'], 'mail'=>$decodedInput['insertRow']['mail']) );
			if( !empty($already) && $already['id']!=$this->memberInfo['member_id'] ){
				$this->outputMain .= '<div id="forum_mmoo-error_message">';
				$this->outputMain .= 'Sorry, please try another '.$this->requiredForMail['question'];
				$this->outputMain .= '</div>';
			}else{
				include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
				$objGroup = new forum_mmoo_data_group();
				$groupInfo = $objGroup->getGroupData($this->oldInfo['group_id']);
				
				if( $groupInfo['allow']=='email' ){
					include_once(FORUM_MMOO_DATA_DIR.'data_mail_change.php');
					$objMailChange = new forum_mmoo_data_mail_change();
					if( !$objMailChange->saveData($this->memberInfo['member_id'], $decodedInput['insertRow']['mail']) ){
						$this->outputMain .= '<div id="forum_mmoo-error_message">';
						$this->outputMain .= 'Failed to change '.$this->requiredForMail['question'].FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
						$this->outputMain .= '</div>';
					}else{
						include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
						$objExplanation = new forum_mmoo_data_explanation();
						$mailData = $objExplanation->getData('change_mail');
						
						include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
						$mailContent = forum_mmoo_replace_mail_tag($mailData['content'],array('member_id'=>$this->memberInfo['member_id']));
						
						if( forum_mmoo_mail($decodedInput['insertRow']['mail'], $mailData['title'], $mailContent) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">';
							$this->outputMain .= 'Sent a mail to the address.<br>Please confirm it and your '.$this->requiredForMail['question'].' will be changed.';
							$this->outputMain .= '</div>';
						}else{
							$objMailChange->executeDelete( array('member_id'=>$this->memberInfo['member_id']) );
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to send a confirmation mail to the address.</div>';
						}
					}
				}else{
					if( $this->objMembers->executeUpdate( array('mail'=>$decodedInput['insertRow']['mail']), array('id'=>$this->memberInfo['member_id'])) ){
						$this->outputMain .= '<div id="forum_mmoo-success_message">';
						$this->outputMain .= 'Your '.$this->requiredForMail['question'].' changed.';
						$this->outputMain .= '</div>';
					}else{
						$this->outputMain .= '<div id="forum_mmoo-error_message">';
						$this->outputMain .= 'Failed to change your '.$this->requiredForMail['question'].FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
						$this->outputMain .= '</div>';
					}
				}
			}
		}
	}
	
	function changeProfile(){
		$decodedInput = $this->objRegister->decodeInput($this->requiredForProfile, $this->request, $this->memberInfo['member_id']);
		foreach($decodedInput['insertRow'] as $key => $val){
			$this->oldInfo[$key] = $val;
		}
		if( empty($decodedInput['errors']) ){
			if( $this->objMembers->executeUpdate($decodedInput['insertRow'], array('id'=>$this->oldInfo['id'])) ){
				$this->outputMain .= '<div id="forum_mmoo-success_message">';
				$this->outputMain .= 'Changed your profile.';
				$this->outputMain .= '</div>';
			}else{
				$this->outputMain .= '<div id="forum_mmoo-error_message">';
				$this->outputMain .= 'Failed to change your profile. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
				$this->outputMain .= '</div>';
			}
		}
	}
	
	function changeNofityMessage(){
		$newFlag = ( $this->oldInfo['message_notify']==FORUM_MMOO_FLAG_YES ) ? FORUM_MMOO_FLAG_NO : FORUM_MMOO_FLAG_YES;
		if( $this->objMembers->executeUpdate( array('message_notify'=>$newFlag), array('id'=>$this->memberInfo['member_id'])) ){
			$this->outputMain .= '<div id="forum_mmoo-success_message">';
			$this->outputMain .= 'Stoped!!';
			$this->outputMain .= '</div>';
			$this->oldInfo['message_notify'] = $newFlag;
		}else{
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'Failed to stop it. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE;
			$this->outputMain .= '</div>';
		}
	}
}
?>