<?php
class forum_mmoo_content_register extends forum_mmoo_content{
	var $errors = array();
	var $errorRequired = false;
	var $errorDuplicate = false;
	var $errorDb = false;
	var $errorMail = false;
	var $insertRow = array();
	
	function __construct($request=array()){
		parent::__construct($request, false);
		
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$this->objMembers = new forum_mmoo_data_members();
	}
	
	function setOutputMain(){
		if( empty($this->request['try_register']) ){
			$this->showTry();
		}else{
			$this->tryRegister();
		}
	}
	
	function tryRegister(){
		include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
		$objMemberInfo = new forum_mmoo_data_member_info();
		$requiredData = $objMemberInfo->getData(true);
		
		$decodedInput = $this->decodeInput($requiredData, $this->request);
		$this->insertRow = $decodedInput['insertRow'];
		$this->errors = $decodedInput['errors'];
		$this->errorRequired = $decodedInput['errorType']['required'];
		$this->errorDuplicate = $decodedInput['errorType']['duplicate'];
		
		$this->insertRow['group_id'] = $this->request['group_id'];
		
		if( empty($this->errors) ){
			$already = $this->objMembers->getMemberInfoByLoginData($this->insertRow);
			if( !empty($already) ){
				$this->errorDuplicate = true;
				$this->showTry();
			}elseif( $this->objMembers->saveData($this->insertRow) ){
				switch( $this->objMembers->savedAs ){
					case 'immediate':
						$this->outputMain .= '<div id="forum_mmoo-success_message">';
						$this->outputMain .= 'welcome on board!';
						$this->outputMain .= '&nbsp;&nbsp;&nbsp;&nbsp;<span class="forum_mmoo-psudo_button" onClick="jQuery(\'#registred_info\').toggle();">See Saved Info</span>';
						$this->outputMain .= '</div>';
						$this->outputMain .= '<div id="registred_info" style="display:none;">';
						$this->outputMain .= '<table class="forum_mmoo-table_confirm">';
						$this->outputMain .= $this->getConfirmTable($requiredData, $this->insertRow);
						$this->outputMain .= '</table>';
						$this->outputMain .= '</div>';
						$this->outputMain .= $this->copyOutputMain('login', $this->insertRow );
					break;
					
					case 'email':
						$to = $this->insertRow['mail'];
						$memberInfo = $this->objMembers->getMemberInfoByRandId($this->objMembers->randId);
						
						include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
						$objExplanation = new forum_mmoo_data_explanation();
						$mailData = $objExplanation->getData('confirm_mail');
						
						include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
						$mailContent = forum_mmoo_replace_mail_tag($mailData['content'],array('member_id'=>$memberInfo['id']));
						
						if( forum_mmoo_mail($to, $mailData['title'], $mailContent) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">';
							$this->outputMain .= 'Email sent to your address.<br>Please activate your account by visiting the URL on it.';
							$this->outputMain .= '</div>';
							$this->outputMain .= '<table class="forum_mmoo-table_confirm">';
							$this->outputMain .= $this->getConfirmTable($requiredData, $this->insertRow);
							$this->outputMain .= '</table>';
						}else{
							$this->objMembers->executeDelete( array('rand_id'=>$this->objMembers->randId) );
							$this->errorMail = true;
							$this->showTry();
						}
					break;
					
					case 'admin':
						$this->outputMain .= '<div id="forum_mmoo-success_message">';
						$this->outputMain .= "Please wait for administrator to check your account.<br>An email is going to be sent when you are allowed in or rejected.";
						$this->outputMain .= '</div>';
						$this->outputMain .= '<table class="forum_mmoo-table_confirm">';
						$this->outputMain .= $this->getConfirmTable($requiredData, $this->insertRow);
						$this->outputMain .= '</table>';
					break;
					
					default:
						$this->showTry();
					break;
				}
			}else{
				$this->errorDb = true;
				$this->showTry();
			}
		}else{
			$this->showTry();
		}
	}
	
	function getConfirmTable($requiredData, $info){
		$return = '';
		
		foreach($requiredData as $val){
			$colName = $this->objMembers->getColName($val['id']);
			
			$return .= '<tr>';
			$return .= '<th>'.$val['question'].'</th>';
			switch( $val['input_type'] ){
				case 'text':
					if($colName=='password'){
						$value = '';
						for($i=0; $i<strlen($info[$colName]); $i++){
							$value .= '*';
						}
					}else{
						$value = $info[$colName];
					}
				break;
				
				case 'radio':
				case 'select':
				case 'check':
					$value = $info[$colName];
				break;
				
				case 'date':
					$value = '';
					$year = substr($info[$colName],0,4);
					$month = substr($info[$colName],4,2);
					$day = substr($info[$colName],6,2);
					if( $year != FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO ){
						$value .= (int)$year.'&nbsp;';
					}
					if( $month != FORUM_MMOO_FLAG_ZERO ){
						$value .= strftime("%B", strtotime($month."/23/2000")).'&nbsp;';
					}
					if( $day != FORUM_MMOO_FLAG_ZERO ){
						$value .= (int)$day;
					}
				break;
			}
			$return .= '<td>'.$value.'</td>';
			$return .= '</tr>';
		}
		return $return;
	}
	
	function getInputTable($requiredData, $oldInfo=array(), $errors=array()){
		foreach($requiredData as $val){
			$colName = $this->objMembers->getColName($val['id']);
			
			$return .= '<tr>';
			$return .= '<th>'.$val['question'];
			if( $val['required'] == FORUM_MMOO_FLAG_YES ){
				$return .= '<span class="forum_mmoo-comment">*required*</span>';
			}
			$return .= '</th>';
			$return .= '<td>';
			
			if( $colName=='login_id' || $colName=='mail' ){
				$return .= '<input type="text" class="forum_mmoo-'.$colName.'" name="'.$colName.'" value="'.$oldInfo[$colName].'" style="ime-mode:disabled;" >';
			}elseif( $colName=='password' ){
				$return .= '<input type="password" name="'.$colName.'">';
			}else{
				switch( $val['input_type'] ){
					case 'text':
						if( $colName=='hn' ){
							$class = 'forum_mmoo-hn';
						}else{
							$class = 'forum_mmoo-free';
						}
						$return .= '<input type="text" class="'.$class.'" name="'.$colName.'" value="'.$oldInfo[$colName].'">';
					break;
					case 'radio':
						$ranges = explode( ',', $val['input_value_range'] );
						foreach($ranges as $range){
							$return .= '<input type="radio" name="'.$colName.'" value="'.$range.'"';
							if( $oldInfo[$colName] == $range ){
								$return .= ' checked';
							}
							$return .= '><span class="forum_mmoo-chk_label">'.$range.'</span>';
						}
					break;
					case 'select':
						$ranges = explode( ',', $val['input_value_range'] );
						$return .= '<select name="'.$colName.'">';
						$return .= '<option value="">----</option>';
						for($i=$ranges[0]; $i<=$ranges[1]; $i+=$ranges[2]){
							$return .= '<option value="'.$i.'"';
							if( $oldInfo[$colName] == $i ){
								$return .= ' selected';
							}
							$return .= '>'.$i.'</option>';
						}
						$return .= '</select>';
					break;
					case 'check':
						$ranges = explode( ',', $val['input_value_range'] );
						$oldInfoChecked = explode( ',', $oldInfo[$colName] );
						foreach($ranges as $key => $range){
							$return .= '<input type="checkbox" class="forum_mmoo-chk" name="'.$colName.'_'.$key.'" value="'.$range.'"';
							if( in_array($range,$oldInfoChecked) ){
								$return .= ' checked';
							}
							$return .= '><span class="forum_mmoo-chk_label">'.$range.'</span>';
						}
					break;
					case 'date':
						$ranges = explode( ',', $val['input_value_range'] );
						if( strlen($oldInfo[$colName]) == 0 ){
							$oldInfoSelectedYear = 99999;
							$oldInfoSelectedMonth = 999;
							$oldInfoSelectedDay = 999;
						}else{
							$oldInfoSelectedYear = (substr($oldInfo[$colName],0,4)==FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO) ? 99999 : (int)substr($oldInfo[$colName],0,4);
							$oldInfoSelectedMonth = (substr($oldInfo[$colName],4,2)==FORUM_MMOO_FLAG_ZERO) ? 999 : (int)substr($oldInfo[$colName],4,2);
							$oldInfoSelectedDay = (substr($oldInfo[$colName],6,2)==FORUM_MMOO_FLAG_ZERO) ? 999 : (int)substr($oldInfo[$colName],6,2);
						}
						if( strlen($ranges[0]) > 0 ){
							if( empty($ranges[1]) ){
								$max = date('Y');
							}else{
								$max = $ranges[1];
							}
							$return .= '<select name="'.$colName.'_year">';
							$return .= '<option value="">----</option>';
							for($i=$ranges[0]; $i<=$max; $i++){
								$return .= '<option value="'.$i.'"';
								if( $oldInfoSelectedYear == $i ){
									$return .= ' selected';
								}
								$return .= '>'.$i.'</option>';
							}
							$return .= '</select>';
						}
						if( $ranges[2]==FORUM_MMOO_FLAG_YES ){
							$return .= '<select name="'.$colName.'_month">';
							$return .= '<option value="">----</option>';
							for($i=1; $i<13; $i++){
								$return .= '<option value="'.$i.'"';
								if( $oldInfoSelectedMonth == $i ){
									$return .= ' selected';
								}
								$return .= '>'.strftime("%B",strtotime($i."/23/2000")).'</option>';
							}
							$return .= '</select>';
						}
						if( $ranges[3]==FORUM_MMOO_FLAG_YES ){
							$return .= '<select name="'.$colName.'_day">';
							$return .= '<option value="">----</option>';
							for($i=1; $i<32; $i++){
								$return .= '<option value="'.$i.'"';
								if( $oldInfoSelectedDay == $i ){
									$return .= ' selected';
								}
								$return .= '>'.$i.'</option>';
							}
							$return .= '</select>';
						}
					break;
					default:
					break;
				}
			}
			if( $errors[$colName] == 'required' ){
				$return .= '<br><span class="forum_mmoo-alert">Required.</span>';
			}
			if( $errors[$colName] == 'duplicate' ){
				$return .= '<br><span class="forum_mmoo-alert">Already taken by other member.</span>';
			}
			$return .= '</td>';
			$return .= '</tr>';
		}
		return $return;
	}
	
	function showTry(){
		if( $this->errorRequired ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">Missing some required info!</div>';
		}
		if( $this->errorDuplicate ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">';
			$this->outputMain .= 'Duplication Error!';
			include_once(FORUM_MMOO_DATA_DIR.'data_general.php');
			$objGeneral = new forum_mmoo_data_general();
			$generalInfo = $objGeneral->getData();
			if( $generalInfo['password_reminder'] == FORUM_MMOO_FLAG_YES ){
				$this->outputMain .= '<br><a href="'.forum_mmoo_make_content_url('pass_remind').'">>>Forgot your password?</a>';
			}
			$this->outputMain .= '</div>';
		}
		if( $this->errorDb ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to make your account. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
		}
		if( $this->errorMail ){
			$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to send you a mail. Can you check your address?</div>';
		}
		
		include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
		$objGroup = new forum_mmoo_data_group();
		$groups = $objGroup->getGroupsNoneGuest();
		
		$this->outputMain .= '<form name="forum_mmoo_form" method="post" action="'.forum_mmoo_make_content_url('register').'">';
		$this->outputMain .= '<input type="hidden" name="try_register" value="1">';
		
		if( count($groups) > 1 ){
			$this->outputMain .= '<div class="forum_mmoo-right" style="margin-bottom:0.3em;">';
			$this->outputMain .= 'Make an Account as : <select name="group_id">';
			foreach($groups as $gr){
				$this->outputMain .= '<option value="'.$gr['id'].'"';
				if( $this->request['group_id']==$gr['id'] ){
					$this->outputMain .= ' selected';
				}
				$this->outputMain .= '>'.$gr['group_name'];
			}
			$this->outputMain .= '</select>';
			
			include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
			$objExplanation = new forum_mmoo_data_explanation();
			$explanation = $objExplanation->getData('group');
			if( !empty($explanation['content']) ){
				$this->outputMain .= '<img src="'.FORUM_MMOO_FILE_URL.'/image/ques_15.jpg" class="mmoo_popup_open_button" alt="member groups?" onClick="mmoo_popOpen(\'group\');">';
				$this->outputMain .= '</div>';
				$this->outputMain .= '<div id="mmoo_popup_group" class="mmoo_popup">';
				$this->outputMain .= '<table>';
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<th class="mmoo_drag_handle">'.$explanation['title'].'</th>';
				$this->outputMain .= '<th width="42px">';
				$this->outputMain .= '<img class="mmoo_popup_close_button" src="'.FORUM_MMOO_FILE_URL.'/image/close_40_15.jpg" alt="Close" onClick="mmoo_popClose(\'group\');">';
				$this->outputMain .= '</th>';
				$this->outputMain .= '</tr>';
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<td colspan="2">';
				$this->outputMain .= $explanation['content'];
				$this->outputMain .= '</td>';
				$this->outputMain .= '</tr>';
				$this->outputMain .= '</table>';
				$this->outputMain .= '</div>';
			}else{
				$this->outputMain .= '</div>';
			}
			$this->outputMain .= '<br style="clear:both;">';
		}else{
			$this->outputMain .= '<input type="hidden" name="group_id" value="'.$groups[0]['id'].'">';
		}
		
		include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
		$objMemberInfo = new forum_mmoo_data_member_info();
		$requiredData = $objMemberInfo->getData(true);
		
		$this->outputMain .= '<table class="forum_mmoo-table_register">';
		$this->outputMain .= $this->getInputTable($requiredData, $this->insertRow, $this->errors);
		$this->outputMain .= '</table>';
		$this->outputMain .= '<div align="center"><span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form.submit();">Register</span></div>';
		$this->outputMain .= '</form>';
	}
	
	function decodeInput($requiredData, $info, $duplicateExceptId=0){
		$insertRow = array();
		$errors = array();
		$errorType = array();
		
		foreach($requiredData as $val){
			$colName = $this->objMembers->getColName($val['id']);
			switch( $val['input_type'] ){
				case 'text':
					$value = wp_kses_post($info[$colName]);
					if( $val['change_required'] == FORUM_MMOO_FLAG_NO ){
						$value = normalize_whitespace(wp_strip_all_tags($value));
					}
				break;
				case 'radio':
				case 'select':
					$value = $info[$colName];
				break;
				
				case 'check':
					$ranges = explode( ',', $val['input_value_range'] );
					$value= '';
					$and = '';
					for($i=0; $i<count($ranges); $i++){
						if( !empty($info[$colName.'_'.$i]) ){
							$value .= $and.$info[$colName.'_'.$i];
							$and = ',';
						}
					}
				break;
				
				case 'date':
					$ranges = explode( ',', $val['input_value_range'] );
					$value = '';
					if( strlen($ranges[0])==0 || strlen($info[$colName.'_year'])==0 ){
						$value .= FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO;
					}else{
						$value .= sprintf('%04d',$info[$colName.'_year']);
					}
					if( $ranges[2]==FORUM_MMOO_FLAG_NO || strlen($info[$colName.'_month'])==0 ){
						$value .= FORUM_MMOO_FLAG_ZERO;
					}else{
						$value .= sprintf('%02d',$info[$colName.'_month']);
					}
					if( $ranges[3]==FORUM_MMOO_FLAG_NO || strlen($info[$colName.'_day'])==0 ){
						$value .= FORUM_MMOO_FLAG_ZERO;
					}else{
						$value .= sprintf('%02d',$info[$colName.'_day']);
					}
					if( $val['required']==FORUM_MMOO_FLAG_YES && strlen($ranges[0])>0 && strlen($info[$colName.'_year'])==0 ){
						$errors[$colName] = 'required';
						$errorType['required'] = true;
					}
					if( $val['required']==FORUM_MMOO_FLAG_YES && $ranges[2]==FORUM_MMOO_FLAG_YES && empty($info[$colName.'_month']) ){
						$errors[$colName] = 'required';
						$errorType['required'] = true;
					}
					if( $val['required']==FORUM_MMOO_FLAG_YES && $ranges[3]==FORUM_MMOO_FLAG_YES && empty($info[$colName.'_day']) ){
						$errors[$colName] = 'required';
						$errorType['required'] = true;
					}
				break;
			}
			$insertRow[$colName] = $value;
			
			if( $val['required']==FORUM_MMOO_FLAG_YES && strlen($value)==0 ){
				$errors[$colName] = 'required';
				$errorType['required'] = true;
			}
			if( $val['allow_duplication'] == FORUM_MMOO_FLAG_NO ){
				$where = array($colName=>$value);
				if( !empty($duplicateExceptId) ){
					$where['id'] = array( '<>' => $duplicateExceptId );
				}
				$resultDuplication = $this->objMembers->getCntRows( $where );
				if( $resultDuplication > 0 ){
					$errors[$colName] = 'duplicate';
					$errorType['duplicate'] = true;
				}
			}
		}
		
		return array('insertRow'=>$insertRow, 'errors'=>$errors, 'errorType'=>$errorType);
	}
}
?>