<?php
include_once(FORUM_MMOO_FUNCTIONS_DIR.'editor.php');

include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
$forum_mmoo_data_instance = new forum_mmoo_data_group();
include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
$forum_mmoo_members_instance = new forum_mmoo_data_members();
include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
$forum_mmoo_explanation_instance = new forum_mmoo_data_explanation();

$forum_mmoo_message_text = '';
$forum_mmoo_message_style = "forum_mmoo-dummy_message";

if( $_POST['forum_mmoo_submit']=='explanation' ){
	if( $_POST[FORUM_MMOO_DASHBOARD_PARAMSUB] != $forum_mmoo_setting_sub_current ){
		$forum_mmoo_errors[] = 'INVALID ACTION';
		$forum_mmoo_data = $forum_mmoo_data_instance->getData();
	}
	if( !empty($forum_mmoo_errors) ){
		$forum_mmoo_message_text = implode( '<br>', $forum_mmoo_errors );
		$forum_mmoo_message_style = "forum_mmoo-error_message";
	}else{
		if( $forum_mmoo_explanation_instance->saveData('group',wp_kses_post($_POST['explanation_title']),wpautop(wp_kses_post($_POST['explanation_content']))) ){
			$forum_mmoo_message_text = 'Changes saved!';
			$forum_mmoo_message_style = "forum_mmoo-success_message";
		}else{
			$forum_mmoo_message_text = 'Failed to save changes!!<br>'.$forum_mmoo_data_instance->error;
			$forum_mmoo_message_style = "forum_mmoo-error_message";
		}
	}
}
$forum_mmoo_explanation = $forum_mmoo_explanation_instance->getData('group');

if( $_POST['forum_mmoo_submit']=='groups' ){
	$forum_mmoo_errors = array();
	$forum_mmoo_insert_row = array();
	
	if( $_POST[FORUM_MMOO_DASHBOARD_PARAMSUB] != $forum_mmoo_setting_sub_current ){
		$forum_mmoo_errors[] = 'INVALID ACTION';
		$forum_mmoo_data = $forum_mmoo_data_instance->getData();
	}else{
		for($i=1; $i<$forum_mmoo_data_instance->max_id; $i++){
			if( $_POST['alive_'.$i]=='yes' ){
				$forum_mmoo_insert_row[$i]['group_name'] = $_POST['group_name_'.$i];
				$forum_mmoo_insert_row[$i]['allow'] = $_POST['allow_'.$i];
				
				$forum_mmoo_auth_params_all = $forum_mmoo_data_instance->getAuthParams();
				foreach($forum_mmoo_auth_params_all as $forum_mmoo_auth_param){
					$forum_mmoo_insert_row[$i][$forum_mmoo_auth_param] = ($_POST[$forum_mmoo_auth_param.'_'.$i]==FORUM_MMOO_FLAG_YES) ? FORUM_MMOO_FLAG_YES : FORUM_MMOO_FLAG_NO;
				}
				
				$forum_mmoo_data[$i] = $forum_mmoo_insert_row[$i];
				$forum_mmoo_data[$i]['id'] = $i;
				
			}elseif( $_POST['alive_'.$i]=='no' ){
				$forum_mmoo_data[$i] = array();
			}
		}
	}
	
	if( !empty($forum_mmoo_errors) ){
		$forum_mmoo_message_text = implode( '<br>', $forum_mmoo_errors );
		$forum_mmoo_message_style = "forum_mmoo-error_message";
	}else{
		if( $forum_mmoo_data_instance->saveData($forum_mmoo_insert_row) ){
			$forum_mmoo_message_text = 'Changes saved!';
			$forum_mmoo_message_style = "forum_mmoo-success_message";
		}else{
			$forum_mmoo_message_text = 'Failed to save changes!!';
			$forum_mmoo_message_style = "forum_mmoo-error_message";
		}
	}
}else{
	$forum_mmoo_data = $forum_mmoo_data_instance->getData();
}

$forum_mmoo_member_num = $forum_mmoo_members_instance->getMemberNum();

function forum_mmoo_echo_checkbox($i, $datum, $authParam, $text, $showForGuest=false){
	if( $showForGuest || $datum['allow']!='guest' ){
		echo '<input type="checkbox" name="'.$authParam,'_'.$i.'" value="'.FORUM_MMOO_FLAG_YES.'"';
		if($datum[$authParam]==FORUM_MMOO_FLAG_YES){
			echo ' checked ';
		}
		echo '>';
		echo $text;
	}
}
?>

<div id="<?php echo $forum_mmoo_message_style; ?>"><?php echo $forum_mmoo_message_text; ?></div>

<form method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<input type="hidden" name="<?php echo FORUM_MMOO_DASHBOARD_PARAMSUB; ?>" value="<?php echo $forum_mmoo_setting_sub_current; ?>">
<input type="hidden" name="forum_mmoo_submit" value="groups">
<div style="margin-bottom: 0; width:78em;">
<table id="forum_mmoo-table_group">
 <tr>
  <th style="width:10em;" rowspan="2">Group Name</th>
  <th colspan="5">Actions<span class="forum_mmoo-comment">*check actions you'd like to allow for the group.</span></th>
  <th style="width:10em;" rowspan="2">Allowing into Forum
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/question_bg9400d3_15.jpg" class="mmoo_popup_open_button" alt="allowing into forum?" onClick="mmoo_popOpen('allow');">
  </th>
 </tr>
 <tr>
  <th style="width:9em;">Viewing</th>
  <th style="width:11em;">Posting</th>
  <th style="width:11em;">Editing</th>
  <th style="width:11em;">Mail Notifications
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/question_bg9400d3_15.jpg" class="mmoo_popup_open_button" alt="Notifications" onClick="mmoo_popOpen('notification');">
  </th>
  <th style="width:12em;">Messages</th>
 </tr>
</table>
</div>

<?php
$forum_mmoo_group_before_exist = true;
foreach($forum_mmoo_data as $forum_mmoo_key => $forum_mmoo_datum){
	if( !empty($forum_mmoo_datum) ){
		$forum_mmoo_display_this_div = '';
		$forum_mmoo_group_alive = 'yes';
		$forum_mmoo_button_this_div = ' display: none; ';
		$forum_mmoo_group_before_exist = true;
		$i = $forum_mmoo_datum['id'];
	}else{
		$forum_mmoo_display_this_div = ' display: none; ';
		$forum_mmoo_group_alive = 'no';
		if( $forum_mmoo_group_before_exist ){
			$forum_mmoo_button_this_div = '';
		}else{
			$forum_mmoo_button_this_div = ' display: none; ';
		}
		$forum_mmoo_group_before_exist = false;
		$i = $forum_mmoo_key;
		$forum_mmoo_datum['allow'] = 'immediate';
	}
?>

<input id="button_<?php echo $i;?>" type=button class="forum_mmoo-button" style="margin:1em; <?php echo $forum_mmoo_button_this_div; ?>" value="Add Group" onClick="jQuery('#alive_<?php echo $i;?>').val('yes'); jQuery('#group_<?php echo $i; ?>').show(); jQuery('#button_<?php echo $i+1; ?>').show(); jQuery('#button_<?php echo $i; ?>').hide();">
<input id="alive_<?php echo $i; ?>" type="hidden" name="alive_<?php echo $i; ?>" value="<?php echo $forum_mmoo_group_alive; ?>">
<div id="group_<?php echo $i; ?>" style="margin-top: 0; width:78em; <?php echo $forum_mmoo_display_this_div; ?>">
<table id="forum_mmoo-table_group">
 <tr>
  <td style="width:10em;">
	<input type="text" style="width:90%;" name="group_name_<?php echo $i; ?>" value="<?php echo $forum_mmoo_datum['group_name']; ?>">
<?php
	if( !empty($forum_mmoo_member_num[$i]) ){
?>
	<div class="forum_mmoo-comment">
		<strong>current members : </strong>
<?php
		foreach( $forum_mmoo_member_num[$i] as $member_status => $member_cnt ){
			echo '<br>',$forum_mmoo_members_instance->status[$member_status]['text'].':'.$member_cnt;
		}
		echo '</div>';
	}elseif( $forum_mmoo_datum['allow'] != 'guest' ){
?>
	<br><input type=button class="forum_mmoo-button" value="Delete This Group" onClick="jQuery('#alive_<?php echo $i;?>').val(''); jQuery('#group_<?php echo $i; ?>').hide();">
<?php
	}
?>
  </td>
  <td style="width:9em;">
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'read_only', 'topics&posts', true);?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'read_profile', 'profile', true);?>
  </td>
  <td style="width:11em;">
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'post', 'posts', true);?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'create_topic', 'create topics', true);?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'delete_topic', 'delete topoics', true);?>
  </td>
  <td style="width:10em;">
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'edit_own', 'own posts');?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'edit_other', "others' posts", true);?>
  </td>
  <td style="width:11em;">
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'notify_own', 'replies (own)');?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'notify_other', 'replies (others)');?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'notify_update', 'topic updates');?>
  </td>
  <td style="width:11em;">
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'send_message', 'sending/receiving');?>
	<br>
	<?php forum_mmoo_echo_checkbox($i, $forum_mmoo_datum,'notify_message', 'notification');?>
  </td>
  <td style="width:10em;">
<?php
	if( $forum_mmoo_datum['allow'] == 'guest' ){
		echo $forum_mmoo_data_instance->allow_type['guest']['text'];
?>
		<input type="hidden" name="allow_<?php echo $i; ?>" value="guest">
<?
	}else{
		$and = '';
		foreach($forum_mmoo_data_instance->allow_type as $forum_mmoo_group_allow_key => $forum_mmoo_group_allow_type){
			if($forum_mmoo_group_allow_key != 'guest'){
				echo $and;
				$and = '<br>';
?>
	<input type="radio" name="allow_<?php echo $i; ?>" value="<?php echo $forum_mmoo_group_allow_key; ?>" <?php if($forum_mmoo_datum['allow']==$forum_mmoo_group_allow_key){echo ' checked ';}?> >
	<?php echo $forum_mmoo_group_allow_type['text']; ?>
<?php
			}
		}
	}
?>
  </td>
 </tr>
</table>
</div>
<?php
}
?>
<br>
<input type="submit" class="forum_mmoo-submit" value="Save Changes">
</form>

<br>

<form method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<input type="hidden" name="<?php echo FORUM_MMOO_DASHBOARD_PARAMSUB; ?>" value="<?php echo $forum_mmoo_setting_sub_current; ?>">
<input type="hidden" name="forum_mmoo_submit" value="explanation">
<div class="forum_mmoo-title_box">Explanation for Member Groups
	<input type="submit" class="forum_mmoo-submit" style="margin-left: 3em;" value="Save">
</div>
	<div class="forum_mmoo-content_box">
		<p>TITLE : <input type="text" style="width:20em;" name="explanation_title" value="<?php echo $forum_mmoo_explanation['title']; ?>"></p>
		<?php echo forum_mmoo_editor( wp_kses_decode_entities($forum_mmoo_explanation['content']), 'explanation_content'); ?>
	</div>
</form>

<div id="mmoo_popup_allow" class="mmoo_popup">
 <table style="width:60em;">
  <tr>
   <th class="mmoo_drag_handle">Ways you can apply when you allow members into your Forum</th>
   <th width="42px">
	<img class="mmoo_popup_close_button" src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/close_40_15.jpg" alt="CLOSE" onClick="mmoo_popClose('allow');">
   </th>
  </tr>
  <tr>
   <td colspan="2">
	<table class="forum_mmoo-table_explain">
	 <tr>
	  <th>Immediate</th>
	  <td>The member will immediately be allowed into the forum<br>--without any confirmation or activation-- when applied.</td>
	 </tr>
	 <tr>
	  <th>Mail</th>
	  <td>When someone applies to the forum, a confirmation mail will be sent from your server.
		<br>The account will be activated when s/he visits the URL on it.
	  </td>
	 </tr>
	 <tr>
	  <th>Manual</th>
	  <td>When someone applies to the forum, you can decide whether to allow him in or not :)
		<br>You can see the new member's info on the <a href="<?php echo $forum_mmoo_setting_page_url; ?>&amp;<?php echo FORUM_MMOO_DASHBOARD_PARAMSUB; ?>=members" target="_blank">MEMBERS</a> setting page.
		<br>When you give him/her permittion/rejection, a mail will be sent from your server.
	  </td>
	 </tr>
	 <tr>
	  <th>Dummy</th>
	  <td>Maybe you would like to make various groups to manage members in your forum.
		<br>But the groups above will show on the sign-up page, so the new member can choose which group to join,
		<br>and too many groups will just make your forum look messy :(
		<br>So, you can use this "dummy" group AFTER the member is settled into your forum 
		<br>without actually telling your members.
		<br>You can change your members' groups on the <a href="<?php echo $forum_mmoo_setting_page_url; ?>&amp;<?php echo FORUM_MMOO_DASHBOARD_PARAMSUB; ?>=members" target="_blank">MEMBERS</a> setting page.
	  </td>
	 </tr>
	</table>
   </td>
  </tr>
 </table>
</div>

<div id="mmoo_popup_notification" class="mmoo_popup">
 <table>
  <tr>
   <th class="mmoo_drag_handle">Notifications</th>
   <th width="42px">
	<img class="mmoo_popup_close_button" src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/close_40_15.jpg" alt="CLOSE" onClick="mmoo_popClose('notification');">
   </th>
  </tr>
  <tr>
   <td colspan="2">
	<p>Members allowed to receive <strong>"replies (own)"</strong> can choose posts (among ones which s/he posted himself) which s/he wants to receive notifications when replied.</p>
	<p>Members allowed to receive <strong>"replies (others')"</strong> can choose posts (from among ALL posts) which s/he wants to receive notifications when replied.</p>
	<p>Members allowed to receive <strong>"topic updates"</strong> can choose topics which s/he wants to receive notifications when someone post a new post.</p>
   </td>
  </tr>
 </table>
</div>
