<?php
include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
$forum_mmoo_data_instance = new forum_mmoo_data_members();

include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
$forum_mmoo_member_info_instance = new forum_mmoo_data_member_info();
$forum_mmoo_member_info = $forum_mmoo_member_info_instance->getData(true);

include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
$forum_mmoo_group_instance = new forum_mmoo_data_group();
$forum_mmoo_member_groups = $forum_mmoo_group_instance->getData();

include_once(FORUM_MMOO_FUNCTIONS_DIR.'search_member.php');

$forum_mmoo_message_text = '';
$forum_mmoo_message_style = "forum_mmoo-dummy_message";

function forum_mmoo_setting_members_pass_info( $current, $narrow_down, $show, $search=null ){
	$passInfo = array();
	$passInfo['visited_before'] = 1;
	$passInfo[FORUM_MMOO_DASHBOARD_PARAMSUB] = $current;
	if( !empty($narrow_down['group_id']) ){
		$passInfo['forum_mmoo_group_id'] = $narrow_down['group_id'];
	}
	if( !empty($narrow_down['status']) ){
		$passInfo['forum_mmoo_status'] = $narrow_down['status'];
	}
	if( !empty($show) ){
		foreach($show as $s){
			$passInfo['forum_mmoo_show_'.$s['id']] = 1;
		}
	}
	if( !empty($search) ){
		$passInfo['passing_search'] = 1;
		$passInfo = array_merge($passInfo, $search);
	}
	return $passInfo;
}

function forum_mmoo_setting_members_get_hidden( $current, $narrow_down, $show, $search=null ){
	$passInfo = forum_mmoo_setting_members_pass_info( $current, $narrow_down, $show, $search );
	$hidden = '';
	foreach( $passInfo as $key => $val ){
		$hidden .= '<input type="hidden" name="'.$key.'" value="'.$val.'">';
	}
	return $hidden;
}

$forum_mmoo_narrow_down = array();
if( !empty($_REQUEST['forum_mmoo_group_id']) ){
	$forum_mmoo_narrow_down['group_id'] = $_REQUEST['forum_mmoo_group_id'];
}
if( !empty($_REQUEST['forum_mmoo_status']) ){
	$forum_mmoo_narrow_down['status'] = $_REQUEST['forum_mmoo_status'];
}

$forum_mmoo_show_info = array();
foreach($forum_mmoo_member_info as $key => $forum_mmoo_m_i){
	if( empty($_REQUEST['visited_before']) ){
		if( !empty($forum_mmoo_m_i['member_col_name']) && $forum_mmoo_m_i['member_col_name']!='password' ){
			$forum_mmoo_show_info[$key] = $forum_mmoo_m_i;
		}
	}else{
		if( !empty($_REQUEST['forum_mmoo_show_'.$forum_mmoo_m_i['id']]) ){
			$forum_mmoo_show_info[$key] = $forum_mmoo_m_i;
		}
	}
}

if( $_REQUEST['passing_search'] == 1 ){
	$forum_mmoo_search_query = forum_mmoo_get_member_search_query($forum_mmoo_member_info, $_REQUEST);
}

$forum_mmoo_page = ( empty($_REQUEST['forum_mmoo_page']) ) ? 1 : $_REQUEST['forum_mmoo_page'];
if( empty($_REQUEST['forum_mmoo_sort']) ){
	$forum_mmoo_sort = '';
	$forum_mmoo_order = '';
}else{
	$forum_mmoo_sort = $_REQUEST['forum_mmoo_sort'];
	$forum_mmoo_order = $_REQUEST['forum_mmoo_order'];
}

$forum_mmoo_pass_info = forum_mmoo_setting_members_pass_info( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, $forum_mmoo_show_info, $forum_mmoo_search_query );

$forum_mmoo_base = $forum_mmoo_setting_page_url;
foreach( $forum_mmoo_pass_info as $key => $val ){
	$forum_mmoo_base .= FORUM_MMOO_DELIM_AMP.$key.'='.$val;
}

$forum_mmoo_where_search = $forum_mmoo_data_instance->mergeWhere(forum_mmoo_get_member_search_where($forum_mmoo_member_info, $forum_mmoo_search_query));
$forum_mmoo_member_num = $forum_mmoo_data_instance->getMemberNumTotal($forum_mmoo_narrow_down, $forum_mmoo_where_search);

if( FORUM_MMOO_DASHBOARD_MEMBER_NUM<$forum_mmoo_member_num ){
	if( !empty($forum_mmoo_sort) ){
		$forum_mmoo_base .= FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort='.$forum_mmoo_sort;
		$forum_mmoo_base .= FORUM_MMOO_DELIM_AMP.'forum_mmoo_order='.$forum_mmoo_order;
	}

	$forum_mmoo_paginate_args = array(
		'base' => $forum_mmoo_base.'%_%'
		, 'format' => FORUM_MMOO_DELIM_AMP.'forum_mmoo_page=%#%'
		, 'total' => ceil( $forum_mmoo_member_num / FORUM_MMOO_DASHBOARD_MEMBER_NUM )
		, 'current' => $forum_mmoo_page
		, 'show_all' => false
		, 'prev_next' => true
		, 'prev_text' => ' << prev '
		, 'next_text' => ' next >> '
		, 'end_size' => 3
		, 'mid_size' => 5
		, 'type' => 'plain'
	);
	$forum_mmoo_paginate_links = '<div class="forum_mmoo-paginate_links">'.paginate_links($forum_mmoo_paginate_args).'</div>';
}else{
	$forum_mmoo_paginate_links = '';
}

if( !empty($_POST['forum_mmoo_change']) ){
	$forum_mmoo_errors = array();
	
	if( $_POST[FORUM_MMOO_DASHBOARD_PARAMSUB] != $forum_mmoo_setting_sub_current ){
		$forum_mmoo_message_text = 'INVALID ACTION';
		$forum_mmoo_message_style = "forum_mmoo-error_message";
	}else{
		switch( $_POST['forum_mmoo_change'] ){
			case 'group':
				if( $forum_mmoo_data_instance->changeMemberGroup($_POST['forum_mmoo_change_member_id'] ,  $_POST['forum_mmoo_new_group_id']) ){
					$forum_mmoo_message_text = 'Group changed';
					$forum_mmoo_message_style = "forum_mmoo-success_message";
				}else{
					$forum_mmoo_message_text = 'Failed to change group!!';
					$forum_mmoo_message_style = "forum_mmoo-error_message";
				}
			break;
			case 'allow':
				if( !$forum_mmoo_data_instance->adminConfirm( $_POST['forum_mmoo_change_member_id'] ) ){
					$forum_mmoo_message_text = 'Failed to activate the account!!';
					$forum_mmoo_message_style = "forum_mmoo-error_message";
				}else{
					include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
					$forum_mmoo_explanation_instance = new forum_mmoo_data_explanation();
					$forum_mmoo_mail_info = $forum_mmoo_explanation_instance->getData('allowed_in');
					
					include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
					$forum_mmoo_mail_content = forum_mmoo_replace_mail_tag( $forum_mmoo_mail_info['content'], array('member_id'=>$_POST['forum_mmoo_change_member_id']) );
					
					$forum_mmoo_changed_member = $forum_mmoo_data_instance->getMemberInfoById($_POST['forum_mmoo_change_member_id']);
					if( forum_mmoo_mail($forum_mmoo_changed_member['mail'], $forum_mmoo_mail_info['title'], $forum_mmoo_mail_content) ){
						$forum_mmoo_message_text = 'Account activated! Mail sent to the new member.';
						$forum_mmoo_message_style = "forum_mmoo-success_message";
					}else{
						$forum_mmoo_message_text = 'Failed to send mail to the new member!!<br>Account is already activated.';
						$forum_mmoo_message_style = "forum_mmoo-error_message";
					}
				}
			break;
			case 'reject':
				if( !$forum_mmoo_data_instance->deleteMember( $_POST['forum_mmoo_change_member_id'] ) ){
					forum_mmoo_pre($_POST);
					$forum_mmoo_message_text = 'Failed to reject!!';
					$forum_mmoo_message_style = "forum_mmoo-error_message";
				}else{
					include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
					$forum_mmoo_explanation_instance = new forum_mmoo_data_explanation();
					$forum_mmoo_mail_info = $forum_mmoo_explanation_instance->getData('rejected');
					
					include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
					$forum_mmoo_mail_content = forum_mmoo_replace_mail_tag( $forum_mmoo_mail_info['content'], array('member_id'=>$_POST['forum_mmoo_change_member_id']) );
					
					$forum_mmoo_changed_member = $forum_mmoo_data_instance->getMemberInfoById($_POST['forum_mmoo_change_member_id'],'all');
					if( forum_mmoo_mail($forum_mmoo_changed_member['mail'], $forum_mmoo_mail_info['title'], $forum_mmoo_mail_content) ){
						$forum_mmoo_message_text = 'Rejection done! <br>Mail of rejection sent.';
						$forum_mmoo_message_style = "forum_mmoo-success_message";
					}else{
						$forum_mmoo_data_instance->adminRecover( $_POST['forum_mmoo_change_member_id'] );
						$forum_mmoo_message_text = 'Unable to send the mail of rejection!!';
						$forum_mmoo_message_style = "forum_mmoo-error_message";
					}
				}
			break;
			case 'leave':
				if( $forum_mmoo_data_instance->deleteMember( $_POST['forum_mmoo_change_member_id'] ) ){
					$forum_mmoo_message_text = 'Account deactivated!';
					$forum_mmoo_message_style = "forum_mmoo-success_message";
				}else{
					$forum_mmoo_message_text = 'Failed to diactivate the account!!';
					$forum_mmoo_message_style = "forum_mmoo-error_message";
				}
			break;
			default:
			break;
		}
	}
}

$forum_mmoo_data = $forum_mmoo_data_instance->getMemberInfoForPage( $forum_mmoo_narrow_down, $forum_mmoo_where_search, '', $forum_mmoo_page, FORUM_MMOO_DASHBOARD_MEMBER_NUM,$forum_mmoo_sort, $forum_mmoo_order);

?>

<div id="<?php echo $forum_mmoo_message_style; ?>"><?php echo $forum_mmoo_message_text; ?></div>

<div style="float:left;">
	<form name="forum_mmoo_narrow_down" method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<?php echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, array(), $forum_mmoo_show_info); ?>
		<div class="forum_mmoo-title_box_small" style="width:18em;">Narrow Down</div>
		<div class="forum_mmoo-content_box_small" style="width:18em;">
			Group&nbsp;:&nbsp;
			<select name="forum_mmoo_group_id">
			<option value="">ALL</option>
<?php
foreach( $forum_mmoo_member_groups as $forum_mmoo_group ){
	if( !empty($forum_mmoo_group) && $forum_mmoo_group['allow']!='guest' ){
?>
			<option value="<?php echo $forum_mmoo_group['id']; ?>" <?php if($_REQUEST['forum_mmoo_group_id']==$forum_mmoo_group['id']){echo ' selected';} ?>><?php echo $forum_mmoo_group['group_name']; ?></option>
<?php
	}
}
?>
			</select>
			<br>Status&nbsp;:&nbsp;
			<select name="forum_mmoo_status">
			<option value="">ALL</option>
<?php
foreach( $forum_mmoo_data_instance->status as $forum_mmoo_status_info ){
	if( !empty($forum_mmoo_status_info['text']) ){
?>
			<option value="<?php echo $forum_mmoo_status_info['flag']; ?>" <?php if($_REQUEST['forum_mmoo_status']==$forum_mmoo_status_info['flag']){ echo ' selected';} ?>><?php echo $forum_mmoo_status_info['text']; ?></option>
<?php
	}
}
?>
			</select>
			<br><input type="button" class="forum_mmoo-button" value="Narrow Down" onClick="document.forum_mmoo_narrow_down.submit();">
			<br><a href="#search">Search with Details</a>
		</div>
	</form>
</div>
<div style="float:left; margin-left:1em;">
	<form name="forum_mmoo_show" method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
		<input type="hidden" name="forum_mmoo_page" value="<?php echo $_REQUEST['forum_mmoo_page']; ?>">
		<div class="forum_mmoo-title_box_small" style="width:30em;">View</div>
		<div class="forum_mmoo-content_box_small" style="width:30em;">
<?php
echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, array(), $forum_mmoo_search_query );
$forum_mmoo_cnt=0;
foreach($forum_mmoo_member_info as $key=> $forum_mmoo_m_i){
	if( $forum_mmoo_m_i['member_col_name'] == 'password' ){
		unset($forum_mmoo_member_info[$key]);
	}else{
?>
			<input type="checkbox" name="forum_mmoo_show_<?php echo $forum_mmoo_m_i['id']; ?>" value=1 <?php if(!empty($forum_mmoo_show_info[$key])){echo ' checked';} ?>><?php echo $forum_mmoo_m_i['question']; ?>&nbsp;
<?php
		if( $forum_mmoo_cnt % 4 == 3){ echo '<br>'; }
		$forum_mmoo_cnt++;
	}
}
?>
			<br><input type="button" class="forum_mmoo-button" value="Show" onClick="document.forum_mmoo_show.submit();">
		</div>
	</form>
</div>

<br style="clear:both;">
<br>

<?php echo $forum_mmoo_paginate_links; ?>

<table id="forum_mmoo-table_members">
 <tr>
  <th>Deactivate Account</th>
  <th>
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort=group_id'.FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=asc';?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/asc.jpg" alt="ascending:Group">
	</a>Group
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort=group_id'.FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=desc';?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/desc.jpg" alt="descending:Group">
	</a>
  </th>
  <th>
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort=status'.FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=asc';?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/asc.jpg" alt="ascending:Status">
	</a>Status
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort=status'.FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=desc';?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/desc.jpg" alt="descending:Status">
	</a>
  </th>
<?php
foreach($forum_mmoo_show_info as $forum_mmoo_show){
?>
  <th>
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort='.$forum_mmoo_data_instance->getColName($forum_mmoo_show['id']).FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=asc'; ?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/asc.jpg" alt="ascending:<?php echo $forum_mmoo_show['id']; ?>">
	</a><?php echo $forum_mmoo_show['question']; ?>
	<a href="<?php echo $forum_mmoo_base.FORUM_MMOO_DELIM_AMP.'forum_mmoo_sort='.$forum_mmoo_data_instance->getColName($forum_mmoo_show['id']).FORUM_MMOO_DELIM_AMP.'forum_mmoo_order=desc'; ?>" style="font-size:0.7em; color:#ffffff;">
	<img src="<?php echo FORUM_MMOO_FILE_URL; ?>/image/desc.jpg" alt="descending:<?php echo $forum_mmoo_show['id']; ?>">
	</a>
  </th>
<?php
}
?>
 </tr>
<?php
if( empty($forum_mmoo_data) ){
?>
</table>
<p class="forum_mmoo-comment">
<?php
	if( empty($_POST) && empty($_REQUEST['forum_mmoo_page']) && empty($_REQUEST['forum_mmoo_sort']) ){
		echo 'No members in your forum yet.';
	}else{
		echo 'No member found.';
	}
?>
</p>
<?php
}else{

	foreach($forum_mmoo_data as $forum_mmoo_member){
?>
 <tr>
  <td>
	<form method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<?php echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, $forum_mmoo_show_info, $forum_mmoo_search_query ); ?>
		<input type="hidden" name="forum_mmoo_change" value='leave'>
		<input type="hidden" name="forum_mmoo_page" value="<?php echo $forum_mmoo_page; ?>">
		<input type="hidden" name="forum_mmoo_change_member_id" value="<?php echo $forum_mmoo_member['id']; ?>">
	<input type="submit" class="forum_mmoo-submit" value="Kick Out!" onClick="confirm('Are You Really Trully Sure??');">
	</form>
  </td>
  <td>
	<form method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<?php echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, $forum_mmoo_show_info, $forum_mmoo_search_query ); ?>
		<input type="hidden" name="forum_mmoo_change" value='group'>
		<input type="hidden" name="forum_mmoo_page" value="<?php echo $forum_mmoo_page; ?>">
		<select name="forum_mmoo_new_group_id">
<?php
		foreach( $forum_mmoo_member_groups as $forum_mmoo_group ){
			if( !empty($forum_mmoo_group) && $forum_mmoo_group['allow']!='guest' ){
?>
			<option value="<?php echo $forum_mmoo_group['id']; ?>" <?php if($forum_mmoo_member['group_id']==$forum_mmoo_group['id']){echo ' selected';} ?>><?php echo $forum_mmoo_group['group_name']; ?></option>
<?php
			}
		}
?>
		</select>
		<input type="hidden" name="forum_mmoo_change_member_id" value="<?php echo $forum_mmoo_member['id']; ?>">
		<input type="submit" class="forum_mmoo-submit" value="Change">
	</form>
  </td>
  <td>
	<form method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<?php echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, $forum_mmoo_show_info, $forum_mmoo_search_query ); ?>
		<input type="hidden" id="forum_mmoo_change_<?php echo $forum_mmoo_member['id']; ?>" name="forum_mmoo_change" value=''>
		<input type="hidden" name="forum_mmoo_page" value="<?php echo $forum_mmoo_page; ?>">
		<input type="hidden" name="forum_mmoo_change_member_id" value="<?php echo $forum_mmoo_member['id']; ?>">
<?php
		echo $forum_mmoo_data_instance->status[$forum_mmoo_member['status']]['text'];
		if( $forum_mmoo_member['status']=='admin'){
?>
		
		<input type="button" class="forum_mmoo-submit" value="Allow In" onClick="jQuery('#forum_mmoo_change_<?php echo $forum_mmoo_member[id]; ?>').val('allow'); submit();">
		<input type="button" class="forum_mmoo-submit" value="Reject" onClick="jQuery('#forum_mmoo_change_<?php echo $forum_mmoo_member[id]; ?>').val('reject'); submit();">
<?php
		}
?>
	</form>
  </td>
<?php
		foreach($forum_mmoo_show_info as $forum_mmoo_show){
?>
  <td>
<?php
			$forum_mmoo_member_info_value = $forum_mmoo_member[$forum_mmoo_data_instance->getColName($forum_mmoo_show['id'])];
			if( $forum_mmoo_show['input_type']=='date' ){
				$forum_mmoo_show_ranges = explode(',',$forum_mmoo_show['input_value_range']);
				$forum_mmoo_member_year = substr($forum_mmoo_member_info_value,0,4);
				$forum_mmoo_member_month = substr($forum_mmoo_member_info_value,4,2);
				$forum_mmoo_member_day = substr($forum_mmoo_member_info_value,6,2);
				$forum_mmoo_member_info_value = '';
				if( strlen($forum_mmoo_show_ranges[0])>0 && $forum_mmoo_member_year!=FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO ){
					$forum_mmoo_member_info_value .= (int)$forum_mmoo_member_year.'&nbsp;';
				}
				if( $forum_mmoo_show_ranges[2]==FORUM_MMOO_FLAG_YES && $forum_mmoo_member_month!=FORUM_MMOO_FLAG_ZERO){
					$forum_mmoo_member_info_value .= strftime("%B", strtotime($forum_mmoo_member_month."/23/2000")).'&nbsp;';
				}
				if( $forum_mmoo_show_ranges[3]==FORUM_MMOO_FLAG_YES && $forum_mmoo_member_day!=FORUM_MMOO_FLAG_ZERO){
					$forum_mmoo_member_info_value .= (int)$forum_mmoo_member_day;
				}
			}
			if( $forum_mmoo_show['member_col_name']=='hn' && $forum_mmoo_member['status']=='immediate' ){
				include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
				$forum_mmoo_topic_instance = new forum_mmoo_data_topics();
				$forum_mmoo_topic_info = $forum_mmoo_topic_instance->executeSelectOne( array('min(blog_page) as blog_page') );
				if( !empty($forum_mmoo_topic_info) && !empty($forum_mmoo_topic_info['blog_page']) ){
					include_once(FORUM_MMOO_FUNCTIONS_DIR.'content_url.php');
					$forum_mmoo_member_info_value = '<a target="_blank" href="'.forum_mmoo_make_content_url('profile', array('forum_mmoo_member'=>$forum_mmoo_member['id']), $forum_mmoo_topic_info['blog_page']).'">'.$forum_mmoo_member_info_value.'</a>';
				}else{
					$forum_mmoo_member_info_value = $forum_mmoo_member_info_value;
				}
			}
			echo $forum_mmoo_member_info_value;
?>
 </td>
<?php
		}
?>
 </tr>
<?php
	}
?>
</table>
<?php
}
?>

<?php echo $forum_mmoo_paginate_links; ?>

<br><br>
<a name="search">Search with Detail</a>
<form name="forum_mmoo_search_form" method="post" action="<?php echo $forum_mmoo_setting_page_url; ?>">
<?php echo forum_mmoo_setting_members_get_hidden( $forum_mmoo_setting_sub_current, $forum_mmoo_narrow_down, $forum_mmoo_show_info, null ); ?>
	<input type="hidden" name="passing_search" value=1>
	<table id="forum_mmoo-table_member_search">
		<?php echo forum_mmoo_get_member_search_table($forum_mmoo_member_info); ?>
	</table>
	<input type="button" class="forum_mmoo-button" value="Search" onClick="document.forum_mmoo_search_form.submit();">
</form>
