<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_mail_change extends forum_mmoo_data{
	function __construct(){
		parent::__construct('mail_change');
		
		$this->rand_id_length = 15;
		$this->memberId = null;
	}
	
	function setAllFields(){
		$fields = array(
			'member_id' => array('col_name'=>'member_id', 'type'=>'int', 'length'=>11)
			, 'rand_id' => array('col_name'=>'rand_id', 'type'=>'char', 'length'=>$this->rand_id_length )
			, 'new_mail' => array('col_name'=>'new_mail', 'type'=>'varchar', 'length'=>256)
		);
		$this->setField($fields);
	}
	
	function getData($memberId){
		return $this->executeSelectOne( '', array('member_id'=>$memberId) );
	}
	
	function saveData($memberId, $newMail){
		$randId = wp_generate_password($this->rand_id_length, false, false);
		return $this->executeInsert( array('member_id'=>$memberId, 'rand_id'=>$randId, 'new_mail'=>$newMail) );
	}
	
	function mailConfirm($randId){
		$result = $this->executeSelectOne( array("member_id", "new_mail", "DATE_FORMAT(updated_time,'%Y%m%d') reg_date"), array('rand_id'=>$randId) );
		if( empty($result) ){
			return false;
		}
		
		$this->memberId = $result['member_id'];
		
		if( $result['reg_date']+FORUM_MMOO_MAIL_CONFIRM_LIMIT<date('Ymd') ){
			$this->executeDelete( array('rand_id' => $randId) );
			return false;
		}
		
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		if( !$objMembers->executeUpdate( array('mail'=>$result['new_mail']), array('id'=>$result['member_id']) ) ){
			return false;
		}
		
		$this->executeDelete( array('rand_id' => $randId) );
		return true;
	}
}