<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_notify_reply extends forum_mmoo_data{
	function __construct(){
		parent::__construct('notify_reply');
	}
	
	function setAllFields(){
		$fields = array(
			'topic_id' => array('col_name'=>'topic_id', 'type'=>'int', 'length'=>11)
			, 'post_id' => array('col_name'=>'post_id', 'type'=>'int', 'length'=>11)
			, 'member_id' => array('col_name'=>'member_id', 'type'=>'int', 'length'=>11)
		);
		$this->setField($fields);
	}
	
	function getDataForMemberAllTopic($memberId){
		$return = array();
		$result = $this->executeSelect( array('topic_id', 'post_id'), array('member_id'=>$memberId) );
		foreach($result as $row){
			$return[$row['topic_id']][] = $row['post_id'];
		}
		return $return;
	}
	
	function getDataForMemberTopicSpecific($memberId, $topicId){
		$return = array();
		$result = $this->executeSelect( array('post_id'), array('member_id'=>$memberId, 'topic_id'=>$topicId) );
		foreach($result as $row){
			$return[$row['post_id']] = true;
		}
		return $return;
	}
	
	function getDataForPost($topicId, $postId){
		$result = $this->executeSelect( array('member_id') , array('topic_id'=>$topicId, 'post_id'=>$postId) );
		$return = array();
		foreach( $result as $row ){
			$return[] = $row['member_id'];
		}
		return $return;
	}
	
	function start($topicId, $postId, $memberId){
		$old = $this->getCntRows( array('member_id'=>$memberId, 'topic_id'=>$topicId, 'post_id'=>$postId) );
		if( $old > 0 ){
			return true;
		}
		return $this->executeInsert( array('member_id'=>$memberId, 'topic_id'=>$topicId, 'post_id'=>$postId) );
	}
	
	function stop($topicId=null, $postId=null, $memberId=null){
		$where = array();
		if( !empty($topicId) ){
			$where['topic_id'] = $topicId;
		}
		if( !empty($postId) ){
			$where['post_id'] = $postId;
		}
		if( !empty($memberId) ){
			$where['member_id'] = $memberId;
		}
		if( empty($where) ){ // too dangerous to do it.
			return false;
		}
		return $this->executeDelete( $where );
	}
}
?>
