<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_notify_topic extends forum_mmoo_data{
	function __construct(){
		parent::__construct('notify_topic');
	}
	
	function setAllFields(){
		$fields = array(
			'member_id' => array('col_name'=>'member_id', 'type'=>'int', 'length'=>11)
			, 'topic_id' => array('col_name'=>'topic_id', 'type'=>'int', 'length'=>11)
		);
		$this->setField($fields);
	}
	
	function getDataForMember($memberId){
		$result = $this->executeSelect( array('topic_id'), array('member_id'=>$memberId) );
		$return = array();
		foreach($result as $row){
			$return[$row['topic_id']] = true;
		}
		return $return;
	}
	
	function getDataForTopic($topicId){
		$result = $this->executeSelect( array('member_id'), array('topic_id'=>$topicId) );
		
		$return = array();
		foreach($result as $row){
			$return[] = $row['member_id'];
		}
		return $return;
	}
	
	function start($topicId, $memberId){
		$old = $this->getCntRows( array('member_id'=>$memberId, 'topic_id'=>$topicId) );
		if( $old > 0 ){
			return true;
		}
		return $this->executeInsert( array('member_id'=>$memberId, 'topic_id'=>$topicId) );
	}
	
	function stop($topicId=null, $memberId=null){
		$where = array();
		if( !empty($topicId) ){
			$where['topic_id'] = $topicId;
		}
		if( !empty($memberId) ){
			$where['member_id'] = $memberId;
		}
		if( empty($where) ){ // dont ever do that
			return false;
		}
		return $this->executeDelete( $where );
	}
}
?>