<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_topics extends forum_mmoo_data{
	function __construct(){
		parent::__construct('topics');
	}
	
	function setAllFields(){
		$fields = array(
			'blog_page' => array('col_name'=>'blog_page', 'type'=>'int', 'length'=>6)
			, 'title' => array('col_name'=>'title', 'type'=>'varchar', 'length'=>256)
			, 'created_by' => array('col_name'=>'created_by', 'type'=>'int', 'length'=>11)
		);
		$this->setField($fields);
	}
	
	function getData($blogPage=null, $sort='', $perPage=null, $page=null){
		$return = array();
		$where = (empty($blogPage)) ? '' : array('blog_page'=>$blogPage) ;
		$limit = $this->makeLimitSql($perPage, $page);
		$result = $this->executeSelect( '', $where, $sort.$limit );
		foreach($result as $row){
			$return[$row['id']] = $row;
		}
		return $return;
	}
	
	function getTopicNum($blogPage=null){
		$where = (empty($blogPage)) ? '' : array('blog_page'=>$blogPage) ;
		return $this->getCntRows($where);
	}
	
	function getTopicInfo($topicId){
		return $this->executeSelectOne( '', array('id'=>$topicId) );
	}
	
	function saveData($blogPage, $title, $createdBy){
		$this->executeInsert( array('blog_page'=>$blogPage, 'title'=>$title, 'created_by'=>$createdBy) );
		$topicId = $this->executeSelectOne( array('max(id) topic_id') );
		include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
		$objThread = new forum_mmoo_data_thread($topicId['topic_id']);
		$objThread->newTable();
		return $topicId;
	}
	
	function deleteTopic($topicId){
		if( !$this->executeDelete( array('id'=>$topicId) ) ){
			return false;
		}
		include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
		$objThread = new forum_mmoo_data_thread($topicId);
		return $objThread->dropTable();
	}
}
?>