<?php
/*
	Plugin Name: forum_mmoo
	Plugin URI: http://www.mmoos.jp/wordpress/forum_mmoo/
	Description: forum_mmoo Insert a simple tag and you get a forum! Real flexible. Customize your own forum!
	Version: 1.0.0
	Author: mmoo
	Author URI: http://www.mmoos.jp/
*/
/*  Copyright 2011  mmoo (http://www.mmoos.jp/contact/)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once( dirname(__FILE__).'/define.php' );
if(FORUM_MMOO_DEBUG){
	ini_set( 'display_errors', 1 );
	include_once(FORUM_MMOO_FUNCTIONS_DIR.'debug.php');
}

/***************************
  Create Data
***************************/
function forum_mmoo_create_data(){
	$neccessaryData = array(
		'psudo_session'
		, 'general'
		, 'group'
		, 'member_info'
		, 'members'
		, 'topics'
		, 'message'
		, 'explanation'
		, 'notify_topic'
		, 'notify_reply'
		, 'mail_change'
	);
	
	foreach($neccessaryData as $datum){
		include_once(FORUM_MMOO_DATA_DIR.'data_'.$datum.'.php');
		$className = 'forum_mmoo_data_'.$datum;
		$instance = new $className();
		$instance->newTable();
		unset($instance);
	}
}
register_activation_hook(__FILE__ , 'forum_mmoo_create_data');

/***************************
  add FORUM-MMOO setting menu to dashboard
***************************/
function forum_mmoo_dashbord_add_setting(){
	include_once( FORUM_MMOO_DASHBOARD_DIR."_settings.php");
}
function forum_mmoo_admin_actions(){
	add_options_page(FORUM_MMOO."'s setting", FORUM_MMOO, 1, FORUM_MMOO_DASHBOARD_VALPAGE, 'forum_mmoo_dashbord_add_setting');
}
add_action('admin_menu', 'forum_mmoo_admin_actions');

/***************************
  add FORUM-MMOO js&css to dashboard&content
***************************/
function forum_mmoo_js_css(){
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-widget');
	wp_enqueue_script('jquery-ui-mouse');
	wp_enqueue_script('jquery-ui-draggable');
	wp_enqueue_script('mmoo_popup', FORUM_MMOO_FILE_URL.'/js/mmoo_popup.js');
	wp_print_scripts();
	wp_enqueue_style('mmoo_popup', FORUM_MMOO_FILE_URL.'/css/mmoo_popup.css');
	wp_enqueue_style('forum_mmoo_style', FORUM_MMOO_FILE_URL.'/css/style.css');
	wp_print_styles();
}
add_action('admin_head', 'forum_mmoo_js_css');
add_action('wp_head', 'forum_mmoo_js_css');

/***************************
  add FORUM-MMOO js&css to dashboard
***************************/
function forum_mmoo_js_css_dashboard(){
	wp_enqueue_script('forum_mmoo_dashboard', FORUM_MMOO_FILE_URL.'/js/dashboard.js');
	wp_print_scripts();
	wp_enqueue_style('forum_mmoo_dashboard', FORUM_MMOO_FILE_URL.'/css/dashboard.css');
	wp_print_styles();
}
add_action('admin_head', 'forum_mmoo_js_css_dashboard');

/***************************
  add FORUM-MMOO js&css to content
***************************/
function forum_mmoo_js_css_content(){
	wp_enqueue_script('forum_mmoo_content', FORUM_MMOO_FILE_URL.'/js/content.js');
	wp_enqueue_script('jquery_socialbutton', FORUM_MMOO_FILE_URL.'/js/jquery_socialbutton.js');
	wp_print_scripts();
	wp_enqueue_style('colors-classic');
	wp_enqueue_style('wp-admin');
	wp_enqueue_style('forum_mmoo_content', FORUM_MMOO_FILE_URL.'/css/content.css');
	wp_print_styles();
}
add_action('wp_head', 'forum_mmoo_js_css_content');

/***************************
  replace tag to forum
***************************/
function forum_mmoo_show_forum_mmoo($content){
	if(!preg_match('|'.FORUM_MMOO_TAG.'|', $content)){
		return $content;
	}else{
		include_once(FORUM_MMOO_CONTENT_DIR.'_content.php');
		return preg_replace('|'.FORUM_MMOO_TAG.'|', $forum_mmoo_replace_output, $content);
	}
}
add_action('the_content', 'forum_mmoo_show_forum_mmoo');

/***************************
  set ID for psudo_session&cookie
***************************/
function forum_mmoo_get_psudo_session_id(){
	if( !session_id() ){
		session_start();
	}
	return session_id();
}
function forum_mmoo_get_psudo_cookie_id(){
	if( empty($_COOKIE['forum_mmoo_psudo_cookie_id']) ){
		return wp_generate_password(20, false, false);
	}else{
		return $_COOKIE['forum_mmoo_psudo_cookie_id'];
	}
}

function forum_mmoo_set_psudo_id(){
	forum_mmoo_get_psudo_session_id();
	$psudoCookieId = forum_mmoo_get_psudo_cookie_id();
	setcookie('forum_mmoo_psudo_cookie_id', $psudoCookieId, FORUM_MMOO_COOKIE_EXPIRE, '/');
}
add_action('init', 'forum_mmoo_set_psudo_id');

/***************************
  clear psudo_session
***************************/
function forum_mmoo_clear_expired_psudo_sessions(){
	include_once(FORUM_MMOO_DATA_DIR.'data_psudo_session.php');
	$forum_mmoo_psudo_session_instance = new forum_mmoo_data_psudo_session();
	$forum_mmoo_psudo_session_instance->clearGarbage();
}
add_action('init', 'forum_mmoo_clear_expired_psudo_sessions');
?>