<?php
function forum_mmoo_editor($content, $id, $small=false) {
	$output = '';
	
	$output .= "<div id='editorcontainer'><textarea class='theEditor' rows='4' cols='40' name='".$id."' id='".$id."'>";
	$output .= $content;
	$output .= "</textarea></div>";
	
	$output .= forum_mmoo_mce($small);

	return $output;
}

function forum_mmoo_mce($small=false) {
	$output = '';
	
	$baseurl = includes_url('js/tinymce');
	$mce_locale = ( '' == get_locale() ) ? 'en' : strtolower( substr(get_locale(), 0, 2) ); // only ISO 639-1
	
	$ext_plugins = '';
	$name = 'mmoo_emotions';
	$url = MMOO_EMOTIONS_FILE_URL.'editor_plugin.js';
	
	if ( is_ssl() ) $url = str_replace('http://', 'https://', $url);
	$plugins[] = '-' . $name;

	$plugurl = dirname($url);
	$strings = $str1 = $str2 = '';
	
		$path = str_replace( WP_PLUGIN_URL, '', $plugurl );
		$path = WP_PLUGIN_DIR . $path . '/langs/';

	if ( function_exists('realpath') )
		$path = trailingslashit( realpath($path) );

	if ( @is_file($path . $mce_locale . '.js') )
		$strings .= @file_get_contents($path . $mce_locale . '.js') . "\n";

	if ( @is_file($path . $mce_locale . '_dlg.js') )
		$strings .= @file_get_contents($path . $mce_locale . '_dlg.js') . "\n";

	if ( 'en' != $mce_locale && empty($strings) ) {
		if ( @is_file($path . 'en.js') ) {
			$str1 = @file_get_contents($path . 'en.js');
			$strings .= preg_replace( '/([\'"])en\./', '$1' . $mce_locale . '.', $str1, 1 ) . "\n";
		}

		if ( @is_file($path . 'en_dlg.js') ) {
			$str2 = @file_get_contents($path . 'en_dlg.js');
			$strings .= preg_replace( '/([\'"])en\./', '$1' . $mce_locale . '.', $str2, 1 ) . "\n";
		}
	}

	if ( ! empty($strings) )
		$ext_plugins .= "\n" . $strings . "\n";


	$ext_plugins .= 'tinyMCEPreInit.load_ext("' . $plugurl . '", "' . $mce_locale . '");' . "\n";
	$ext_plugins .= 'tinymce.PluginManager.load("' . $name . '", "' . $url . '");' . "\n";
	
	$arrButtons1 = array(
		'bold'
		, 'italic'
		, 'strikethrough'
		, 'underline'
		, 'fontsizeselect'
		, 'forecolor'
		, 'backcolor'
	);
	$arrButtons2 = array(
		'link'
		, 'unlink'
		, 'image'
		, 'mmoo_emotions'
		, 'sup'
		, 'sub'
		, 'charmap'
	);
	if( $small ){
		$mce_buttons = implode($arrButtons1, ',');
		$mce_buttons_2 = implode($arrButtons2, ',');
	}else{
		$mce_buttons = implode(array_merge($arrButtons1,$arrButtons2), ',');
		$mce_buttons_2 = '';
	}
	$mce_buttons_3 = $mce_buttons_4 = '';
	
	$initArray = array (
		'mode' => 'specific_textareas',
		'editor_selector' => 'theEditor',
		'width' => '100%',
		'theme' => 'advanced',
		'skin' => 'wp_theme',
		'theme_advanced_buttons1' => $mce_buttons,
		'theme_advanced_buttons2' => $mce_buttons_2,
		'theme_advanced_buttons3' => $mce_buttons_3,
		'theme_advanced_buttons4' => $mce_buttons_4,
		'language' => $mce_locale,
		'spellchecker_languages' => $mce_spellchecker_languages,
		'theme_advanced_toolbar_location' => 'top',
		'theme_advanced_toolbar_align' => 'left',
		'theme_advanced_statusbar_location' => 'bottom',
		'theme_advanced_resizing' => true,
		'theme_advanced_resize_horizontal' => false,
		'dialog_type' => 'modal',
		'formats' => "{
			alignleft : [
				{selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles : {textAlign : 'left'}},
				{selector : 'img,table', classes : 'alignleft'}
			],
			aligncenter : [
				{selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles : {textAlign : 'center'}},
				{selector : 'img,table', classes : 'aligncenter'}
			],
			alignright : [
				{selector : 'p,h1,h2,h3,h4,h5,h6,td,th,div,ul,ol,li', styles : {textAlign : 'right'}},
				{selector : 'img,table', classes : 'alignright'}
			],
			strikethrough : {inline : 'del'}
		}",
		'relative_urls' => false,
		'remove_script_host' => false,
		'convert_urls' => false,
		'apply_source_formatting' => false,
		'remove_linebreaks' => true,
		'gecko_spellcheck' => true,
		'keep_styles' => false,
		'entities' => '38,amp,60,lt,62,gt',
		'accessibility_focus' => true,
		'tabfocus_elements' => 'major-publishing-actions',
		'media_strict' => false,
		'paste_remove_styles' => true,
		'paste_remove_spans' => true,
		'paste_strip_class_attributes' => 'all',
		'paste_text_use_dialog' => true,
		'extended_valid_elements' => 'article[*],aside[*],audio[*],canvas[*],command[*],datalist[*],details[*],embed[*],figcaption[*],figure[*],footer[*],header[*],hgroup[*],keygen[*],mark[*],meter[*],nav[*],output[*],progress[*],section[*],source[*],summary,time[*],video[*],wbr',
		'wpeditimage_disable_captions' => $no_captions,
		'wp_fullscreen_content_css' => "$baseurl/plugins/wpfullscreen/css/wp-fullscreen.css",
		'plugins' => implode( ',', $plugins ),
	);
	
	$language = $initArray['language'];

	if ( 'en' != $language )
		include_once(ABSPATH . WPINC . '/js/tinymce/langs/wp-langs.php');

	$mce_options = '';
	foreach ( $initArray as $k => $v ) {
		if ( is_bool($v) ) {
			$val = $v ? 'true' : 'false';
			$mce_options .= $k . ':' . $val . ', ';
			continue;
		} elseif ( !empty($v) && is_string($v) && ( ('{' == $v{0} && '}' == $v{strlen($v) - 1}) || ('[' == $v{0} && ']' == $v{strlen($v) - 1}) || preg_match('/^\(?function ?\(/', $v) ) ) {
			$mce_options .= $k . ':' . $v . ', ';
			continue;
		}

		$mce_options .= $k . ':"' . $v . '", ';
	}

	$mce_options = rtrim( trim($mce_options), '\n\r,' );

	$output .= '<script type="text/javascript">';
	$output .= '/* <![CDATA[ */';
	$output .= 'tinyMCEPreInit = {';
	$output .= '	base : "'.$baseurl.'",';
	$output .= '	suffix : "",';
	$output .= '	mceInit : {'.$mce_options.'},';
	$output .= "	load_ext : function(url,lang){var sl=tinymce.ScriptLoader;sl.markDone(url+'/langs/'+lang+'.js');sl.markDone(url+'/langs/'+lang+'_dlg.js');}";
	$output .= '};';
	$output .= '/* ]]> */';
	$output .= '</script>';
	$output .=  "<script type='text/javascript' src='$baseurl/tiny_mce.js?$version'></script>\n";
	if ( 'en' != $language && isset($lang) )
		$output .= "<script type='text/javascript'>\n$lang\n</script>\n";
	else
		$output .= "<script type='text/javascript' src='$baseurl/langs/wp-langs-en.js?$version'></script>\n";

	$output .= '<script type="text/javascript">';
	$output .= '/* <![CDATA[ */';
	$output .= $ext_plugins;

	$output .= "(function(){var t=tinyMCEPreInit,sl=tinymce.ScriptLoader,ln=t.mceInit.language,th=t.mceInit.theme,pl=t.mceInit.plugins;sl.markDone(t.base+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'_dlg.js');tinymce.each(pl.split(','),function(n){if(n&&n.charAt(0)!='-'){sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'.js');sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'_dlg.js');}});})();";

	$output .= 'tinyMCE.init(tinyMCEPreInit.mceInit);';
	$output .= '/* ]]> */';
	$output .= '</script>';
	
	return $output;
}
?>
