<?php
function forum_mmoo_get_member_search_table($searchItems){
	include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
	$objMembers = new forum_mmoo_data_members();
	
	$return = '';
	foreach($searchItems as $search){
		$colName = $objMembers->getColName($search['id']);
		$return .= '<tr>';
		$return .= '<th>'.$search['question'].'</th>';
		$return .= '<td>';
		switch( $search['input_type'] ){
			case 'text':
				$return .= '<input type="text" name="'.$colName.'">';
			break;
			case 'select':
				$ranges = explode( ',', $search['input_value_range'] );
				$return .= '<select name="'.$colName.'_min">';
				$return .= '<option value="">----</option>';
				for($i=$ranges[0]; $i<=$ranges[1]; $i+=$ranges[2]){
					$return .= '<option value="'.$i.'">'.$i.'</option>';
				}
				$return .= '</select> - ';
				$return .= '<select name="'.$colName.'_max">';
				$return .= '<option value="">----</option>';
				for($i=$ranges[0]; $i<=$ranges[1]; $i+=$ranges[2]){
					$return .= '<option value="'.$i.'">'.$i.'</option>';
				}
				$return .= '</select>';
			break;
			case 'radio':
			case 'check':
				$ranges = explode( ',', $search['input_value_range'] );
				foreach($ranges as $key => $range){
					$return .= '<input type="checkbox" name="'.$colName.'_'.$key.'" value="'.$range.'"><span class="forum_mmoo-chk_label">'.$range.'</span>';
				}
			break;
			case 'date':
				$ranges = explode( ',', $search['input_value_range'] );
				$and = '';
				if( strlen($ranges[0]) > 0 ){
					$and = '<br>';
					if( empty($ranges[1]) ){
						$max = date('Y');
					}else{
						$max = $ranges[1];
					}
					$return .= 'Year : <select name="'.$colName.'_year_min">';
					$return .= '<option value="">----</option>';
					for($i=$ranges[0]; $i<=$max; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select> - ';
					$return .= '<select name="'.$colName.'_year_max">';
					$return .= '<option value="">----</option>';
					for($i=$ranges[0]; $i<=$max; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select>';
				}
				if( $ranges[2]==FORUM_MMOO_FLAG_YES ){
					$return .= $and;
					$and = 'Month : <br>';
					$return .= '<select name="'.$colName.'_month_min">';
					$return .= '<option value="">----</option>';
					for($i=1; $i<13; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select> - ';
					$return .= '<select name="'.$colName.'_month_max">';
					$return .= '<option value="">----</option>';
					for($i=1; $i<13; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select>';
				}
				if( $ranges[3]==FORUM_MMOO_FLAG_YES ){
					$return .= $and;
					$and = '<br>';
					$return .= 'Day : <select name="'.$colName.'_day_min">';
					$return .= '<option value="">----</option>';
					for($i=1; $i<32; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select> - ';
					$return .= '<select name="'.$colName.'_day_max">';
					$return .= '<option value="">----</option>';
					for($i=1; $i<32; $i++){
						$return .= '<option value="'.$i.'">'.$i.'</option>';
					}
					$return .= '</select>';
				}
			break;
			default:
			break;
		}
		$return .= '</td>';
		$return .= '</tr>';
	}
	return $return;
}

function forum_mmoo_get_member_search_query($searchItems, $request){
	include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
	$objMembers = new forum_mmoo_data_members();
	include_once(FORUM_MMOO_FUNCTIONS_DIR.'search_string.php');
	$return = array();
	foreach($searchItems as $key => $search){
		$colName = $objMembers->getColName($search['id']);
		switch( $search['input_type'] ){
			case 'text':
				if( strlen($request[$colName]) > 0 ){
					$where[$colName] = forum_mmoo_search_string_escape($request[$colName]);
				}
			break;
			case 'select':
				if( strlen($request[$colName.'_min']) > 0 ){
					$where[$colName.'_min'] = $request[$colName.'_min'];
				}
				if( strlen($request[$colName.'_max']) > 0 ){
					$where[$colName.'_max'] = $request[$colName.'_max'];
				}
			break;
			case 'radio':
			case 'check':
				$ranges = explode( ',', $search['input_value_range'] );
				$arrSearch = array();
				foreach($ranges as $key => $range){
					if( strlen($request[$colName.'_'.$key]) > 0 ){
						$where[$colName.'_'.$key] = $request[$colName.'_'.$key];
					}
				}
			break;
			case 'date':
				if( strlen($request[$colName.'_year_min']) > 0 ){
					$where[$colName.'_year_min'] = $request[$colName.'_year_min'];
				}
				if( strlen($request[$colName.'_year_max']) > 0 ){
					$where[$colName.'_year_max'] = $request[$colName.'_year_max'];
				}
				if( strlen($request[$colName.'_month_min']) > 0 ){
					$where[$colName.'_month_min'] = $request[$colName.'_month_min'];
				}
				if( strlen($request[$colName.'_month_max']) > 0 ){
					$where[$colName.'_month_max'] = $request[$colName.'_month_max'];
				}
				if( strlen($request[$colName.'_day_min']) > 0 ){
					$where[$colName.'_day_min'] = $request[$colName.'_day_min'];
				}
				if( strlen($request[$colName.'_day_max']) > 0 ){
					$where[$colName.'_day_max'] = $request[$colName.'_day_max'];
				}
			break;
			default:
			break;
		}
	}
	return $where;
}

function forum_mmoo_get_member_search_where($searchItems, $request){
	include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
	$objMembers = new forum_mmoo_data_members();
	include_once(FORUM_MMOO_FUNCTIONS_DIR.'search_string.php');
	$where = array();
	foreach($searchItems as $search){
		$colName = $objMembers->getColName($search['id']);
		switch( $search['input_type'] ){
			case 'text':
				if( strlen($request[$colName]) > 0 ){
					$arrSearch = forum_mmoo_search_string_into_array($request[$colName]);
					$where[] = forum_mmoo_get_search_string_where($colName, $arrSearch);
				}
			break;
			case 'select':
				if( strlen($request[$colName.'_min']) > 0 ){
					$where[] = $objMembers->makeWhereOne( $colName, array( '>=' => $request[$colName.'_min'] ));
				}
				if( strlen($request[$colName.'_max']) > 0 ){
					$where[] = $objMembers->makeWhereOne( $colName, array( '<=' => $request[$colName.'_max'] ));
				}
			break;
			case 'radio':
			case 'check':
				$ranges = explode( ',', $search['input_value_range'] );
				$arrSearch = array();
				foreach($ranges as $key => $range){
					if( strlen($request[$colName.'_'.$key]) > 0 ){
						$arrSearch[] = $request[$colName.'_'.$key];
					}
				}
				if( !empty($arrSearch) ){
					$where[] = forum_mmoo_get_search_string_where($colName, $arrSearch);
				}
			break;
			case 'date':
				if( strlen($request[$colName.'_year_min']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',1,4)', array( '<>' => FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',1,4)', array( '>=' => sprintf('%04d',$request[$colName.'_year_min'] )));
				}
				if( strlen($request[$colName.'_year_max']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',1,4)', array( '<>' => FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',1,4)', array( '<=' => sprintf('%04d',$request[$colName.'_year_max'] )));
				}
				if( strlen($request[$colName.'_month_min']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',5,2)', array( '<>' => FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',5,2)', array( '>=' => sprintf('%02d',$request[$colName.'_month_min'] )));
				}
				if( strlen($request[$colName.'_month_max']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',5,2)', array( '<>' => FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',5,2)', array( '<=' => sprintf('%02d',$request[$colName.'_month_max'] )));
				}
				if( strlen($request[$colName.'_day_min']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',7,2)', array( '<>' => FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',7,2)', array( '>=' => sprintf('%02d',$request[$colName.'_day_min'] )));
				}
				if( strlen($request[$colName.'_day_max']) > 0 ){
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',7,2)', array( '<>' => FORUM_MMOO_FLAG_ZERO ));
					$where[] = $objMembers->makeWhereOne( 'SUBSTRING('.$colName.',7,2)', array( '<=' => sprintf('%02d',$request[$colName.'_day_max'] )));
				}
			break;
			default:
			break;
		}
	}
	return $where;
}

?>
